unit folders;
{$DEFINE DelphiFucksMyAsmCode} // what a shame for borland corp. that i am forced to define this directive

interface
uses SysUtils;

type
  string14=string[14];
  TPathStr=shortstring;
{$IFNDEF delphi6}
  int64=double;
{$ENDIF}

function  RemoveBackSlash(path:string):string;
function  fileCreationTime(const f:TSearchRec):TDateTime;
function  fileLastAccessTime(const f:TSearchRec):TDateTime;
function  fileLastWriteTime(const f:TSearchRec):TDateTime;
function  fileShortName(const f:TSearchRec):string14;
function  BigFileSize(const f:TSearchRec):int64;
function  GetCurrentDrive:char;
function  DriveType(drive:char):integer;
function  VolumeSerialNumber(const drive:char):cardinal;
function  FileSystemName(const drive:char):string;
function  IsRootFolder(const path:TPathStr):boolean;
function  DriveMounted(drive:char):boolean;
function  DirSize(const dir:TPathStr):extended;
function  fileBinaryType(filename:TFileName):longint;
function  fileInUse(const fileName:TFileName):boolean;
function  fileCRC32(const fileName:TFileName):cardinal;
function  fileOwner(const fileName:TFileName):string;
function  fileVersion(const Filename:TFileName):shortstring;
procedure fileFill(var f:file; count:longint=-1; color:byte=0; offset:longint=-1); overload;
procedure fileFill(const filename:TFileName; count:longint=-1; color:byte=0; offset:longint=-1); overload;
procedure fileDiscolor(var f:file; colorFind,colorReplace:byte; count:longint=-1; offset:longint=-1); overload;
procedure fileDiscolor(const filename:TFileName; colorFind,colorReplace:byte; count:longint=-1; offset:longint=-1); overload;
function  fileWipe(const filename:TFileName; delete:boolean=true; color:byte=0):boolean; 
function  fileScan(const filename:TFileName; const search:string):longint; overload;
function  exe_and_wait(const fileName:TFileName; Visibility:integer):integer;
function  fileSpaceInsert(var f:file; const count:longint; const color:byte=0; offset:longint=-1):boolean; overload;
function  fileSpaceInsert(const filename:TFileName; const count:longint; const color:byte=0; offset:longint=-1):boolean; overload;
function  fileSpaceDelete(var f:file; count:longint; offset:longint=-1):boolean; overload;
function  fileSpaceDelete(const filename:TFileName; count:longint; offset:longint=-1):boolean; overload;

implementation
uses windows;

function  RemoveBackSlash(path:string):string;
begin
  result:=path;
  if length(result)>2 then
    if (length(result)=3) and (result[2]=':') then else
    if path[length(result)]='\' then result:=copy(result,1,length(result)-1);
end;

function  FileCreationTime(const f:TSearchRec):TDateTime;
var d:cardinal;
begin
  try FileTimeToDosDateTime(f.FindData.ftCreationTime,LongRec(d).Hi,LongRec(d).Lo);
      result:=FileDateToDateTime(d);
  except result:=0;
  end;
end;

function  FileLastAccessTime(const f:TSearchRec):TDateTime;
var d:cardinal;
begin
  try FileTimeToDosDateTime(f.FindData.ftLastAccessTime,LongRec(d).Hi,LongRec(d).Lo);
      result:=FileDateToDateTime(d);
  except result:=0;
  end;
end;

function  FileLastWriteTime(const f:TSearchRec):TDateTime;
var d:cardinal;
begin
  try FileTimeToDosDateTime(f.FindData.ftLastWriteTime,LongRec(d).Hi,LongRec(d).Lo);
      result:=FileDateToDateTime(d);
  except result:=0;
  end;
end;

function  fileShortName(const f:TSearchRec):string14;
var i:longint;
begin
  result:='';
  for i:=0 to 13 do
    if f.FindData.cAlternateFileName[i]=#0 then break
    else result:=result+f.FindData.cAlternateFileName[i];
  if result='' then result:=f.Name;
end;

function  BigFileSize(const f:TSearchRec):int64;
begin
  result:=f.FindData.nFileSizeHigh shl 32 or f.FindData.nFileSizeLow;
end;

function  GetCurrentDrive:char;
var tmp:string;
begin
  tmp:=GetCurrentDir;
  if length(tmp)>0 then result:=tmp[1] else result:=#0;
end;

function  DriveType(drive:char):integer;
var tmp:string[4];
begin
  tmp:=drive+':\'#0;
  result:=GetDriveType(@tmp[1]);
end;

function  VolumeSerialNumber(const drive:char):cardinal;
var SN,MCL,FSF:dword;
begin
  result:=0;
  if GetVolumeInformation(PChar(drive+':\'),nil,0,@SN,MCL,FSF,nil,0) then result:=dword(SN);
end;

function  FileSystemName(const drive:char):string;
var
  SN,MCL,FSF:dword;
  buffer:array[0..$FF] of char;
  pbuf:PChar absolute buffer;
begin
  result:='';
  if GetVolumeInformation(PChar(drive+':\'),nil,0,@SN,MCL,FSF,@buffer,sizeof(buffer)) then
  result:=pbuf;
end;

function  IsRootFolder(const path:TPathStr):boolean;
var
  f:TSearchRec;
  found:integer;
begin
  result:=true;
  found:=FindFirst(RemoveBackSlash(path)+'\*.*',faAnyFile,f);
  if found=0 then if (f.Name='.') and (f.Attr and faDirectory<>0) then result:=false;
  FindClose(found);
end;

function  DriveMounted(drive:char):boolean;
begin
  result:=false;
  drive:=UpCase(drive);
  if not(drive in ['A'..'Z']) then exit;
  result:=GetLogicalDrives and (1 shl (ord(drive)-ord('A')))<>0;
end;

function  dirSize(const dir:TPathStr):extended;
label finish;
var
  f:TSearchRec;
  found:integer;
begin
  result:=0;
  found:=FindFirst(RemoveBackSlash(dir)+'\*.*',faAnyFile,f);
  if found<>0 then exit;
  while (f.Name='.') or (f.Name='..') do
    if FindNext(f)<>0 then goto finish;
  repeat
    if f.Attr and faDirectory=0 then
      result:=result+BigFileSize(f)
    else
      result:=result+DirSize(RemoveBackSlash(dir)+'\'+f.Name);  // rekurze
  until FindNext(f)<>0;
finish:
  FindClose(found);
end;

function  fileBinaryType(filename:TFileName):longint;
var b:boolean;
begin
  filename:=filename+#0;
  b:=GetBinaryType(@filename[1],dword(result));
  if not b then result:=-1;
end;

function  fileInUse(const fileName:TFileName):boolean;
var HFileRes:HFILE;
begin
  result:=false;
  if not FileExists(fileName) then exit;
  HFileRes:=CreateFile(pchar(fileName),GENERIC_READ or GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  Result:=(HFileRes=INVALID_HANDLE_VALUE);
  if not Result then CloseHandle(HFileRes);
end;

function  fileCRC32(const fileName:TFileName):dword;
const
  CRC:array[0..255] of DWord=(
  $00000000,$77073096,$EE0E612C,$990951BA,
  $076DC419,$706AF48F,$E963A535,$9E6495A3,
  $0EDB8832,$79DCB8A4,$E0D5E91E,$97D2D988,
  $09B64C2B,$7EB17CBD,$E7B82D07,$90BF1D91,
  $1DB71064,$6AB020F2,$F3B97148,$84BE41DE,
  $1ADAD47D,$6DDDE4EB,$F4D4B551,$83D385C7,
  $136C9856,$646BA8C0,$FD62F97A,$8A65C9EC,
  $14015C4F,$63066CD9,$FA0F3D63,$8D080DF5,
  $3B6E20C8,$4C69105E,$D56041E4,$A2677172,
  $3C03E4D1,$4B04D447,$D20D85FD,$A50AB56B,
  $35B5A8FA,$42B2986C,$DBBBC9D6,$ACBCF940,
  $32D86CE3,$45DF5C75,$DCD60DCF,$ABD13D59,
  $26D930AC,$51DE003A,$C8D75180,$BFD06116,
  $21B4F4B5,$56B3C423,$CFBA9599,$B8BDA50F,
  $2802B89E,$5F058808,$C60CD9B2,$B10BE924,
  $2F6F7C87,$58684C11,$C1611DAB,$B6662D3D,
  $76DC4190,$01DB7106,$98D220BC,$EFD5102A,
  $71B18589,$06B6B51F,$9FBFE4A5,$E8B8D433,
  $7807C9A2,$0F00F934,$9609A88E,$E10E9818,
  $7F6A0DBB,$086D3D2D,$91646C97,$E6635C01,
  $6B6B51F4,$1C6C6162,$856530D8,$F262004E,
  $6C0695ED,$1B01A57B,$8208F4C1,$F50FC457,
  $65B0D9C6,$12B7E950,$8BBEB8EA,$FCB9887C,
  $62DD1DDF,$15DA2D49,$8CD37CF3,$FBD44C65,
  $4DB26158,$3AB551CE,$A3BC0074,$D4BB30E2,
  $4ADFA541,$3DD895D7,$A4D1C46D,$D3D6F4FB,
  $4369E96A,$346ED9FC,$AD678846,$DA60B8D0,
  $44042D73,$33031DE5,$AA0A4C5F,$DD0D7CC9,
  $5005713C,$270241AA,$BE0B1010,$C90C2086,
  $5768B525,$206F85B3,$B966D409,$CE61E49F,
  $5EDEF90E,$29D9C998,$B0D09822,$C7D7A8B4,
  $59B33D17,$2EB40D81,$B7BD5C3B,$C0BA6CAD,
  $EDB88320,$9ABFB3B6,$03B6E20C,$74B1D29A,
  $EAD54739,$9DD277AF,$04DB2615,$73DC1683,
  $E3630B12,$94643B84,$0D6D6A3E,$7A6A5AA8,
  $E40ECF0B,$9309FF9D,$0A00AE27,$7D079EB1,
  $F00F9344,$8708A3D2,$1E01F268,$6906C2FE,
  $F762575D,$806567CB,$196C3671,$6E6B06E7,
  $FED41B76,$89D32BE0,$10DA7A5A,$67DD4ACC,
  $F9B9DF6F,$8EBEEFF9,$17B7BE43,$60B08ED5,
  $D6D6A3E8,$A1D1937E,$38D8C2C4,$4FDFF252,
  $D1BB67F1,$A6BC5767,$3FB506DD,$48B2364B,
  $D80D2BDA,$AF0A1B4C,$36034AF6,$41047A60,
  $DF60EFC3,$A867DF55,$316E8EEF,$4669BE79,
  $CB61B38C,$BC66831A,$256FD2A0,$5268E236,
  $CC0C7795,$BB0B4703,$220216B9,$5505262F,
  $C5BA3BBE,$B2BD0B28,$2BB45A92,$5CB36A04,
  $C2D7FFA7,$B5D0CF31,$2CD99E8B,$5BDEAE1D,
  $9B64C2B0,$EC63F226,$756AA39C,$026D930A,
  $9C0906A9,$EB0E363F,$72076785,$05005713,
  $95BF4A82,$E2B87A14,$7BB12BAE,$0CB61B38,
  $92D28E9B,$E5D5BE0D,$7CDCEFB7,$0BDBDF21,
  $86D3D2D4,$F1D4E242,$68DDB3F8,$1FDA836E,
  $81BE16CD,$F6B9265B,$6FB077E1,$18B74777,
  $88085AE6,$FF0F6A70,$66063BCA,$11010B5C,
  $8F659EFF,$F862AE69,$616BFFD3,$166CCF45,
  $A00AE278,$D70DD2EE,$4E048354,$3903B3C2,
  $A7672661,$D06016F7,$4969474D,$3E6E77DB,
  $AED16A4A,$D9D65ADC,$40DF0B66,$37D83BF0,
  $A9BCAE53,$DEBB9EC5,$47B2CF7F,$30B5FFE9,
  $BDBDF21C,$CABAC28A,$53B39330,$24B4A3A6,
  $BAD03605,$CDD70693,$54DE5729,$23D967BF,
  $B3667A2E,$C4614AB8,$5D681B02,$2A6F2B94,
  $B40BBE37,$C30C8EA1,$5A05DF1B,$2D02EF8D);
var
  f:file;
  bytesRead:dword;
  buffer:array[0..4095] of byte;
  i:integer;
begin
  FileMode := 0;
  result:=$FFFFFFFF;
  AssignFile(f,fileName);
  {$IFOPT I+}{$I-}reset(f,1);{$I+}{$ELSE}reset(f,1);{$ENDIF}
  if IOResult<>0 then exit;
  repeat
    blockRead(F,buffer,SizeOf(buffer),bytesRead);
    for i:=1 to bytesRead do
      result:=(result shr 8) xor CRC[buffer[i] xor (result and $000000FF)];
  until BytesRead = 0;
  CloseFile(f);
  result:=not result;
end;

function  fileOwner(const fileName:TFileName):string;
var
  SecDescr:PSecurityDescriptor;
  SizeNeeded,SizeNeeded2:DWORD;
  OwnerSID:PSID;
  OwnerDefault:BOOL;
  OwnerName,DomainName:PChar;
  OwnerType:SID_NAME_USE;
begin
  result:='';
  GetMem(SecDescr,1024);
  GetMem(OwnerSID,SizeOf(PSID));
  GetMem(OwnerName,1024);
  GetMem(DomainName,1024);
  try
    if not GetFileSecurity(PChar(FileName),OWNER_SECURITY_INFORMATION,SecDescr,1024,SizeNeeded) then exit;
    if not GetSecurityDescriptorOwner(SecDescr,OwnerSID,OwnerDefault) then exit;
    SizeNeeded:=1024; SizeNeeded2:=1024;
    if not LookupAccountSID(nil,OwnerSID,OwnerName,SizeNeeded,DomainName,SizeNeeded2,OwnerType) then exit;
    result:=DomainName+'@'+OwnerName;
  finally
    FreeMem(SecDescr);
    FreeMem(OwnerName);
    FreeMem(DomainName);
  end;
end;

function  fileVersion(const Filename:TFileName):shortstring;
var
  dwHandle:THandle;
  dwSize:DWORD;
  lpData,lpData2:pointer;
  uiSize:UINT;
begin
  Result:='';
  dwSize:=GetFileVersionInfoSize(PChar(FileName),dwSize); dwHandle:=0;
  if dwSize<>0 then begin
    GetMem(lpData,dwSize);
    if GetFileVersionInfo(PChar(FileName),dwHandle,dwSize,lpData) then begin
      uiSize:=Sizeof(TVSFixedFileInfo);
      VerQueryValue(lpData,'\',lpData2,uiSize);
      with PVSFixedFileInfo(lpData2)^ do result:=Format('%d.%02d.%02d.%02d',[HiWord(dwProductVersionMS),LoWord(dwProductVersionMS),HiWord(dwProductVersionLS),LoWord(dwProductVersionLS)]);
    end;
    FreeMem(lpData,dwSize);
  end;
end;

procedure changeColor(buffer:pointer; count:integer; colorFind,colorReplace:byte);
{$IFDEF DelphiFucksMyAsmCode}
begin
  while count>0 do begin
    if byte(buffer^)=colorFind then byte(buffer^):=colorReplace;
    inc(dword(buffer));
    dec(count);
  end;
end;
{$ELSE}
assembler;
asm
  mov  edi,buffer
  mov  al,colorFind
  mov  ah,colorReplace
  cmp  ah,al
  je   @exitline
  mov  ecx,count
  inc  ecx
@1:
  jcxz @exitline
  repne scasb
  jcxz @exitline
  dec  edi
  inc  ecx
  mov  esi,edi
  repe scasb
  dec  edi
  inc  ecx
  mov  ebx,edi
  sub  ebx,esi
  sub  edi,ebx
  xchg ebx,ecx
  xchg al,ah
  rep  stosb
  xchg ebx,ecx
  xchg al,ah
  jmp  @1
@exitline:
end;
{$ENDIF}

procedure fileDiscolor(var f:file; colorFind,colorReplace:byte; count:longint=-1; offset:longint=-1); overload;
var
  i,j,origpos,position:integer;
  buffer:array[0..4095] of char;
begin
  if (count=0) or (colorFind=colorReplace) then exit;
  origpos:=filePos(f);
  if offset<>-1 then seek(f,offset);
  if count=-1 then count:=System.fileSize(f)-filePos(f);
  j:=count mod sizeof(buffer); i:=pred(count div sizeof(buffer));
  for i:=i downto 0 do begin
    position:=filepos(f);
    blockread(f,buffer,sizeof(buffer));
    changeColor(@buffer,sizeof(buffer),colorFind,colorReplace);
    seek(f,position);
    blockwrite(f,buffer,sizeof(buffer));
  end;
  if j<>0 then begin
    position:=filepos(f);
    blockread(f,buffer,j);
    changeColor(@buffer,j,colorFind,colorReplace);
    seek(f,position);
    blockwrite(f,buffer,j);
  end;
  seek(f,origpos);
end;

procedure fileDiscolor(const filename:TFileName; colorFind,colorReplace:byte; count:longint=-1; offset:longint=-1); overload;
var f:file;
begin
  AssignFile(f,filename);
  FileMode:=fmOpenReadWrite;
  reset(f,1);
  if IOResult=0 then fileDiscolor(f,count,colorFind,colorReplace,offset);
end;

procedure fileFill(var f:file; count:longint=-1; color:byte=0; offset:longint=-1); overload;
var
  i,j,origpos:integer;
  buffer:array[0..4095] of char;
begin
  if count=0 then exit;
  origpos:=filePos(f);
  if offset<>-1 then seek(f,offset);
  if count=-1 then count:=System.fileSize(f)-filePos(f);
  j:=count mod sizeof(buffer); i:=pred(count div sizeof(buffer));
  fillchar(buffer,sizeof(buffer),color);
  for i:=i downto 0 do
    blockwrite(f,buffer,sizeof(buffer));
  if j<>0 then
    blockwrite(f,buffer,j);
  seek(f,origpos);
end;

procedure fileFill(const filename:TFileName; count:longint=-1; color:byte=0; offset:longint=-1); overload;
var f:file;
begin
  AssignFile(f,filename);
  FileMode:=fmOpenReadWrite;
  reset(f,1);
  if IOResult=0 then fileFill(f,count,color,offset);
end;

function  fileWipe(const filename:TFileName; delete:boolean=true; color:byte=0):boolean;
var
  buffer:array[0..4095] of byte;
  i,j:integer;
  f:file;
begin
  result:=false; FileMode:=fmOpenWrite;
  AssignFile(f,filename);
  if IOResult<>0 then exit;
  fillchar(buffer,sizeof(buffer),color);
  i:=System.filesize(f);
  j:=i mod sizeof(buffer); i:=pred(i div sizeof(buffer));
  for i:=i downto 0 do
    blockwrite(f,buffer,sizeof(buffer));
  if j<>0 then
    blockwrite(f,buffer,j);
  close(f);
  result:=true;
  if delete then result:=DeleteFile(PChar(filename));
end;

function  fileScan(var f:file; const search:string):longint; overload;
label finish;
var i,j,len,origpos:longint; c:char;
begin
  result:=-1;
  len:=length(search); if len=0 then exit;
  origpos:=filePos(f);
  i:=pred(System.fileSize(f)-len-origpos);
  while i>0 do
    for j:=1 to len do begin
      blockread(f,c,1);
      dec(i);
      if c=search[j] then begin
        dec(i);
        if j=len then begin
          result:=filepos(f)-len;
          goto finish;
        end;
      end else break;
    end;
finish:
  seek(f,origpos);
end;

function  fileScan(const filename:TFileName; const search:string):longint; overload;
var f:file;
begin
  result:=-1;
  fileMode:=fmOpenRead;
  assignFile(f,filename);
  reset(f,1);
  if IOResult<>0 then exit;
  result:=fileScan(f,search);
  closeFile(f);
end;

function  exe_and_wait(const fileName:TFileName; Visibility:integer):integer;
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  { Naplnme strukturu StartupInfo. }
  FillChar(StartupInfo,sizeof(StartupInfo),0);
  StartupInfo.CB:=SizeOf(StartupInfo);
  StartupInfo.dwFlags:=STARTF_USESHOWWINDOW; // spustit v normlnm okn
  StartupInfo.wShowWindow:=Visibility;       // zpsob zobrazen okna (normln, maximalizovan,...)
  if not CreateProcess(
    nil,
    PChar(FileName),       // pkazov dka - to, co se spust
    nil,                   // bezpenostn atributy vzniklho procesu...
    nil,                   // ... a vlkna - ani jedno nepotebujeme
    False,                 // ddn handl - nechceme
    NORMAL_PRIORITY_CLASS, // proces m normln prioritu
    nil,                   // ukazatel na promnn prosted - hodnota nil znamen jejich zddn od volajcho procesu
    nil,                   // aktuln adres, nil opt znamen zddn
    StartupInfo,           // ukazatele na potebn struktury
    ProcessInfo) then result:=-1 // pi chyb vracme -1
  else begin
    WaitForSingleObject(ProcessInfo.hProcess,INFINITE);
    GetExitCodeProcess(ProcessInfo.hProcess,cardinal(result)); // Nakonec vrtme nvratov kd procesu.
  end;
end;

function  fileSpaceInsert(var f:file; const count:longint; const color:byte=0; offset:longint=-1):boolean;
var
  buffer:array[0..4095] of char;
  si,i,transferred:longint;
begin
  result:=false;
  if offset=-1 then offset:=filepos(f);
  si:=system.fileSize(f);
  if (count<1) or (offset<0) or (offset>si) then exit;
  while si-sizeof(buffer)>=offset do begin
    seek(f,si-sizeof(buffer));
    blockread(f,buffer,sizeof(buffer),transferred);
    dec(si,sizeof(buffer));
    seek(f,si+count);
    blockwrite(f,buffer,sizeof(buffer),transferred);
  end;
  i:=(si-offset) mod sizeof(buffer);
  if i<>0 then begin
    seek(f,si-i);
    blockread(f,buffer,i,transferred);
    seek(f,si+count-i);
    blockwrite(f,buffer,i,transferred);
  end;
  fillchar(buffer,sizeof(buffer),color);
  seek(f,offset);
  for i:=pred(count div sizeof(buffer)) downto 0 do 
    blockwrite(f,buffer,sizeof(buffer),transferred);
  i:=count mod sizeof(buffer);
  if i<>0 then
    blockwrite(f,buffer,i,transferred);
  seek(f,offset);
  result:=true;
end;

function  fileSpaceInsert(const filename:TFileName; const count:longint; const color:byte=0; offset:longint=-1):boolean;
var f:file;
begin
  AssignFile(f,filename);
  FileMode:=fmOpenReadWrite;
  reset(f,1);
  if IOResult=0 then result:=fileSpaceInsert(f,count,color,offset) else result:=false;
end;

function  fileSpaceDelete(var f:file; count:longint; offset:longint=-1):boolean;
var
  buffer:array[0..4095] of char;
  i,si,origSize,transferred:longint;
begin
  result:=false;
  origSize:=System.fileSize(f);
  if offset=-1 then offset:=filepos(f);
  if (count<1) or (offset<0) or (offset>=origSize) then exit;
  if offset+count>origSize then count:=origSize-offset;
  si:=offset+count;
  while si+sizeof(buffer)<=origSize do begin
    seek(f,si);
    blockread(f,buffer,sizeof(buffer),transferred);
    seek(f,si-count);
    blockwrite(f,buffer,sizeof(buffer),transferred);
    inc(si,sizeof(buffer));
  end;
  i:=(origSize-offset-count) mod sizeof(buffer);
  if i<>0 then begin
    seek(f,si);
    blockread(f,buffer,i,transferred);
    seek(f,si-count);
    blockwrite(f,buffer,i,transferred);
  end;
  seek(f,origSize-count);
  truncate(f);
  close(f);
  FileMode:=2;
  reset(f,1);
  seek(f,offset);
  result:=true;
end;

function  fileSpaceDelete(const filename:TFileName; count:longint; offset:longint=-1):boolean;
var f:file;
begin
  AssignFile(f,filename);
  FileMode:=fmOpenReadWrite;
  reset(f,1);
  if IOResult=0 then result:=fileSpaceDelete(f,count,offset) else result:=false;
end;

end.
