unit handy;
{$DEFINE delphi6}
{$DEFINE remote}
{$H+,B-}

interface

uses
  Windows, Messages, SysUtils, DateUtils, {$IFDEF delphi6}Variants,{$ENDIF}
  Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, registry, ExtCtrls, ShellAPI, IniFiles, ScktComp, Menus,
  ComCtrls, MMSystem, ClipBrd, ShlObj, Printers, BDE, PerlRegEx,
  IdGlobal, IdFtp, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdIntercept, IdLogBase, IdLogDebug, IdAntiFreezeBase, IdAntiFreeze, WinInet,
  tools,    // ruzne pomocne funkce
  vartable, // tabulka symbolu
  folders;  // prace se soubory a adresari
const
  IDENTIFIERCHAR:set of char=['A'..'Z','_','a'..'z'];
  CHUNKCHARS:set of char=['0'..'9','A'..'Z','_','a'..'z'];
  HEXCHARS:set of char=['0'..'9','A'..'F','a'..'f'];
  DAY_MS            =86400000; // milisekund za den
  FILEMAPPING_MAX   =128*1024*1024;
  // konstanty pro FTP prenos
  FTP_ATTRIBUTE_DIR =1;
  FTP_ATTRIBUTE_FILE=2;
  FTP_ATTRIBUTE_LINK=3;
  FTP_ATTRIBUTE_DISK=4;
  FTP_CONNECTED     =0;
  FTP_PATH          =1;
  FTP_SHOW_PASSWORD =2;
  FTP_READING       =3;
  FTP_WRITING       =4;
  FTP_BYTES_READ    =5;
  FTP_BYTES_WRITTEN =6;
  FTP_RECV          =7;
  FTP_SENT          =8;
  FTP_STATUS        =9;
  FTP_STATUS_CODE   =10;
  FTP_CFG_MAX       =10;
  // indexy StatusBar.Panels
  sbpERRORS         =0;
  sbpPOSITION       =1;
  sbpFTP            =2;
  // file index u pole lokalnich souboru
  fiNAME            =0;
  fiSIZE            =1;
  fiAGE             =2;
  fiLASTWRITETIME   =2;
  fiCREATIONTIME    =3;
  fiNODE            =3;
  fiLASTACCESSTIME  =4;
  fiOWNER           =4;
  fiATTR            =5;
  fiSHORT           =6;
  fiGROUP           =6;
  fiMAX             =6;
  // signatury blokuu (viz tez "blSIGN")
  sgnIF             =1;
  sgnREPEAT         =2;
  sgnWHILE          =3;
  sgnFOR            =4;
  sgnFUNC           =5;
  sgnMAX            =5;
  // indexy v poli blocks[] a blockstack[]
  blSIGN            =0; // signatura, rika o jaky ridici blok se vlastne jedna (viz "sngXXXX")
  blROW             =1; // na jakem radku blok zacina
  blCOND            =2; // na jakem sloupci tohoto radku zacina podminka (pro if, for, while)
  blFUNC            =2; // pokud [blSIGN]=sgnFUNC (tedy blokem je funkce), pak v [blFUNC] je jeji jmeno
  blCOL             =2; // sem se ulozi sloupec, na ktery se beh programu vrati po zpracovani funkce
  blREF             =3; // sem se ulozi radek, - " -
  // indexy pole blockstack[] pro for..endfor
  frCOND            =2; // sloupec, na kterem zacina podminka cyklu
  frSTEP            =3; // sloupec, na kterem zacina prikaz, ktery se provadi po kazdem cyklu (napr. "i++")
  frEND             =4; // radek, kde je umisten "endfor"
  frMAX             =4;
  // indexy pole blockstack[] pro while..endwhile
  wlCOL             =2; // sloupec, kde zacina podminka (invariant) cyklu
  wlLOOP            =3; // radek, na kterem je "endwhile"

  ifBRANCH          =2; // index blockstack[] (pro strukturu if..endif), od ktereho (az do konce) zacinaji cisla radek vetvi "elseif" (posledni muze byt i "else")
  STACKMAX          =255; //maximalni pocet zanoreni ridicich cyklu a funkci do sebe
  // indexy stopek (TimeWatch)
  twUNUSED          =0;
  twMEASURE         =1;
  twLAP             =2;
  // konstanty TRegistry.GetKeyInfo
  gkiKEYS           =1;
  gkiVALUES         =2;
  gkiLONGEST        =3;
  gkiMODIFIED       =4;
  // indexy v poli, ktere eviduje includovane skripty
  incEXITLINE       =0;
  incFILENAME       =1;
  incSTART          =2;
  // attributy otevrenych souboruu
  fileR_CREATE      =$0400; // pro cteni, vytvorit pokud neexistuje
  fileW_DONT_CREATE =$0800; // pro zapis, nevytvaret pokud neexistuje
  fileAPPEND        =$1000; // po otevreni presunout pozici na konec
  fileFORCE_RW      =$2000; // musi byt pro cteni i zapis
  fileWAS_READ_ONLY =$4000; // pred otevrenim
  fileOPENED        =$8000;
  fileBUFSIZE       =65536;
  // nazvy zacatkuu a koncuu ridicich struktur
  tabBlock:array[0..sgnMAX] of string[8]=('','if','repeat','while','for','func');
  tabBlockEnd:array[0..sgnMAX] of string[8]=('','endif','until','endwhile','endfor','endfunc');
  logCAPACITY       =32768; // kapacita logu
  // zakladni jednoznakove termy jazyka
  CONCATCHAR        =':';
  MEMBERCHAR        ='.';
  COMMACHAR         =',';
  COMMENTCHAR       ='#';
  ARRAYCHAR         ='[';

type
  TFileMapping=record
    MsgId:string[63];
    HMsg:THandle;
    HMap:THandle;
    FileName:TFileName;
    size:longint;
    Buffer:string;
    sync:boolean;
    view:PChar;
  end;
  PFileNode=^TFileNode;
  TFileNode=record
    f:file;
    filename:TFileName;
    attr:word;
    next:PFileNode;
  end;
  TFrmMain = class(TForm)
    OutputListBox: TListBox;
    DebugListBox: TListBox;
    Timer: TTimer;
    FTP: TIdFTP;
    PopupMenu1: TPopupMenu;
    MenuItemHorizontalScroller: TMenuItem;
    MenuItemRestart: TMenuItem;
    MenuItemShowErrors: TMenuItem;
    IdLogDebug: TIdLogDebug;
    IdAntiFreeze: TIdAntiFreeze;
    StatusBar: TStatusBar;
    MenuItemClear: TMenuItem;
    MenuItemEscapeQuits: TMenuItem;
    MenuItemSaveToFile: TMenuItem;
    SaveDialog: TSaveDialog;
    PerlRegEx: TPerlRegEx;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FTPConnected(Sender: TObject);
    procedure FTPDisconnected(Sender: TObject);
    procedure FTPWorkBegin(Sender: TObject; AWorkMode: TWorkMode; const AWorkCountMax: Integer);
    procedure MenuItemHorizontalScrollerClick(Sender: TObject);
    procedure MenuItemRestartClick(Sender: TObject);
    procedure MenuItemShowErrorsClick(Sender: TObject);
    procedure MenuItemClearClick(Sender: TObject);
    procedure FTPStatus(axSender: TObject; const axStatus: TIdStatus; const asStatusText: String);
    procedure FTPWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure FTPWork(Sender: TObject; AWorkMode: TWorkMode; const AWorkCount: Integer);
    procedure IdLogDebugLogItem(ASender: TComponent; var AText: String);
    procedure StatusBarClick(Sender: TObject);
    procedure OutputListBoxKeyPress(Sender: TObject; var Key: Char);
    procedure MenuItemEscapeQuitsClick(Sender: TObject);
    procedure MenuItemSaveToFileClick(Sender: TObject);
  private
    scriptname:ShortString;
    remote,ftpcfg:variant;
    autoclose,escquits,logfollow,dragged:boolean;
    multirem,hscroll:integer;
    timestart,scriptStart,scriptEnd:double;
    timewatch:byte;
    fatal:string;
    script:TStringList;
    vars:TVarTable;
    row,col:integer;
    blocks,blockstack:variant;
    local:variant;
    includes:variant;
    reg:TRegistry;
    files:PFileNode;
    filemapping:TFileMapping;
    procedure Run;
    procedure files_open(const _filename:TFileName; const mode:word);
    function  files_read(const fileshand:PFileNode; till:variant):variant;
    procedure closeFiles;
    procedure getLocalFiles(wildcard:shortstring='');
    function  getLocalFile(const name:string):variant;
    procedure getRemoteFiles(const wildcard:shortstring='');
    function  fileIndex(name:string; const files:variant):longint;
    function  fileItem(name:variant):PFileNode;
    function  atline:ShortString;
    procedure blockPush(var block:variant; n:integer);
    procedure blockPop(var block:variant);
    procedure blockAppend(var block:variant; index:integer; n:variant);
    function  blockAt(row:integer):variant;
    procedure scan;
    function  isFunction(id:string):boolean;
    procedure skipWhitespace;
    procedure skipFragment;
    function  arithmetic(a:variant; c:char; b:variant):variant;
    function  nextChar:char;
    function  readChar:char;
    function  readChunk:string;
    function  readMethodName:string;
    function  readTernarOperator(c:variant):variant;
    function  readFunction(funcid:string):variant;
    function  readAssignment(const key:string):boolean;
    function  readStructure(a:variant):variant;
    function  readVariable(a:variant):variant;
    function  readExpression(const level:byte=0):variant;
    function  readExp:variant;
    function  readComment:boolean;
    procedure processRow;
    procedure processStatement;
    procedure processLine(const s:string);
  public
    procedure log(const s:string);
    procedure log_(const s:string);
    procedure RefreshStatus;
    procedure WMDropFiles(var M:TWMDropFiles); message WM_DROPFILES;
    procedure WMTimeChange(var Msg:TMessage); message WM_TIMECHANGE;
    procedure WMClipBoardChange(var Message:TMessage); message WM_DRAWCLIPBOARD;
    procedure WndMove(var msg:TMessage); message WM_Move;
    procedure WMDeviceChange(var Msg:TMessage); message WM_DEVICECHANGE;
    procedure WMDisplayChange(var Msg:TWMDisplayChange); message WM_DISPLAYCHANGE;
    procedure WndProc(var Message:TMessage); override;
  end;

var
  FrmMain: TFrmMain;

implementation

procedure TFrmMain.WndProc(var Message:TMessage);
begin
  with Message do if Msg=FileMapping.HMsg then begin
    with FileMapping do if sync and (HMap<>0) then begin
      view:=MapViewOfFile(HMap,FILE_MAP_READ,0,0,Size);
      Buffer:=view;
      UnmapViewOfFile(view);
      if isFunction('filemapping') then processLine('filemapping()');
    end;
    result:=0;
  end else inherited;
end;


function  TFrmMain.fileIndex(name:string; const files:variant):longint;
var i:longint;
begin
  result:=-1;
  if (name='') or  not varIsArray(files) then exit;
  name:=LowerCase(name);
  if name[length(name)]='.' then SetLength(name,length(name)-1);
  for i:=0 to UBound(files) do
    if LowerCase(VarToStr(files[i]))=name then begin
      result:=i;
      exit;
    end;
end;

function  TFrmMain.fileItem(name:variant):PFileNode;
begin
  if (VarToStr(name)='') {or (VarToStr(name)='in') or (VarToStr(name)='out')} then
    result:=nil else result:=files;
  if VarIsNumeric(name) then begin
    while (result<>nil) and (name>0) do
      if LowerCase(result^.filename)<>name then begin
        result:=result^.next;
        dec(name);
      end else break;
    exit;
  end;
  name:=LowerCase(name);
  while result<>nil do
    if LowerCase(result^.filename)<>name then result:=result^.next
    else break;
end;

procedure TFrmMain.files_open(const _filename:TFileName; const mode:word); // otevira/vytvari soubor do pole 'files'
var
  fileshlp,filesnew:PFileNode;
  fa:integer;
begin
  if (_filename='') {or (_filename='in') or (_filename='out')} then exit;
  fa:=fileGetAttr(_filename);
  if fa=-1 then // otevirany soubor neexistuje
    if mode and (fmOpenWrite or fmOpenReadWrite)=fmOpenRead then begin // otevirame pro cteni neexistujici soubor - chyba
      log_('<can''t open '''+_filename+''' for input - file does not exist');
      exit;
    end else if mode and fileW_DONT_CREATE<>0 then begin // otevirame neexistujici soubor pro zapis ale nemuzeme ho vytvorit - chyba
      log_('<can''t open '''+_filename+''' for output - file does not exist, must not create');
      exit;
    end
  else if (fa and faReadOnly<>0) and (mode and (fmOpenWrite or fmOpenReadWrite)<>fmOpenRead) then // otevirany soubor existuje ale je jen pro cteni a my do nej chceme i zapisovat
    if mode and fileFORCE_RW=0 then begin // nemame povoleno "nasilim" zmenit jeho atribut, abychom do nej mohli i zapisovat
      log_('<can''t open '''+_filename+''' for input/output - file is READ ONLY'+atline);
      exit;
    end else if fileSetAttr(_filename,fa and not faReadOnly)<>0 then begin // nepodarilo se nam odstranit atribut "read-only" u oteviraneho souboru
      log_('<can''t open '''+_filename+''' for input/output - failing setting file''s attributes'+atline);
      exit;
    end else fa:=fa or fileWAS_READ_ONLY;
  new(filesnew);
  with filesnew^ do begin
    filename:=_filename;
    assignfile(f,filename);
    FileMode:=fmOpenReadWrite;
    reset(f,1);
    if IOResult<>0 then begin
      FileMode:=fmOpenRead;
      reset(f,1);
      if IOResult<>0 then begin
        dispose(filesnew);
        log_('<can''t open '''+_filename+''''+atline);
        exit;
      end;
    end else attr:=fileOPENED or fmOpenReadWrite;
    attr:=attr or (fa and fileWAS_READ_ONLY);
    next:=nil;
  end;
  if files<>nil then begin
    fileshlp:=files;
    while fileshlp^.next<>nil do fileshlp:=fileshlp^.next;
    fileshlp^.next:=filesnew;
  end else files:=filesnew;
end;

function  TFrmMain.files_read(const fileshand:PFileNode; till:variant):variant;
const MAXREAD=4096;
var
  c:char;
  i:integer;
  function files_read_(amount:integer):AnsiString;
  begin
    result:='';
    while amount>0 do begin
      blockread(fileshand^.f,c,1);
      result:=result+c;
      dec(till); dec(amount);
    end;
  end;
begin
  result:=''; i:=1;
  if VarType(till) in [VarInteger,varDouble] then begin
    till:=round(till);
    if (fileshand=nil) or (till<1) then exit;
    while till>=MAXREAD do begin
      result:=result+files_read_(MAXREAD);
      dec(till,MAXREAD);
    end;
    result:=result+files_read_(till);
  end else if (VarToStr(till)<>'') and (fileshand<>nil) then
    repeat
      blockread(fileshand^.f,c,1);
      result:=result+c;
      if c=System.Copy(till,i,1) then
        if i=length(till) then begin
          result:=System.Copy(result,1,length(result)-length(till));
          break;
        end else inc(i)
      else i:=1;
    until false;
end;

procedure TFrmMain.getLocalFiles(wildcard:shortstring='');
var
  sr:TSearchRec;
  found,i:integer;
begin
  local:=null; i:=0; if wildcard='' then wildcard:='*.*';
  found:=FindFirst(wildcard,faAnyFile,sr);
  if found=0 then if sr.Name='.' then found:=FindNext(sr);
  while found=0 do begin
    if VarIsArray(local) then varArrayRedim(local,UBound(local)+1) else local:=VarArrayCreate([0,0],varVariant);
    local[i]:=sr.Name; inc(i);
    found:=FindNext(sr);
  end;
  FindClose(sr);
end;

function  TFrmMain.getLocalFile(const name:string):variant;
var
  sr:TSearchRec;
  i,j:integer;
  s:string;
begin
  result:='';
  if FindFirst(name,faAnyFile,sr)<>0 then begin
    if readChar='.' then if LowerCase(readChunk)='exists' then result:=integer(FileExists(name));
    exit;
  end;
  if nextChar=MEMBERCHAR then begin
    j:=col;
    s:=LowerCase(VarToStr(readMethodName));
    if (s='name') or (s='filename') then result:=sr.Name
    else if s='fullname' then result:=ExpandFileName(sr.Name)
    else if (s='size') or (s='filesize') then result:=sr.FindData.nFileSizeHigh shl 32 or sr.FindData.nFileSizeLow
    else if s='creationtime' then result:=FileCreationTime(sr)
    else if s='lastaccesstime' then result:=FileLastAccessTime(sr)
    else if (s='lastwritetime') or (s='lastmodified') then result:=FileLastWriteTime(sr)
    else if (s='datetime') or (s='age') then result:=FileDateToDateTime(sr.Time)
    else if (s='attr') or (s='attributes') then result:=sr.Attr
    else if s='attrreadonly' then result:=integer(sr.Attr and FILE_ATTRIBUTE_READONLY<>0)
    else if s='attrhidden' then result:=integer(sr.Attr and FILE_ATTRIBUTE_HIDDEN<>0)
    else if s='attrsystem' then result:=integer(sr.Attr and FILE_ATTRIBUTE_SYSTEM<>0)
    else if s='attrdirectory' then result:=integer(sr.Attr and FILE_ATTRIBUTE_DIRECTORY<>0)
    else if s='attrvolumeid' then result:=integer(sr.Attr and faVolumeId<>0)
    else if s='attrnormal' then result:=integer(sr.Attr and FILE_ATTRIBUTE_NORMAL<>0)
    else if s='attrcompressed' then result:=integer(sr.Attr and FILE_ATTRIBUTE_COMPRESSED<>0)
    else if s='isdir' then result:=integer(sr.Attr and faDirectory<>0)
    else if (s='attrarchive') or (s='archive') then result:=integer(sr.Attr and faArchive<>0)
    else if (s='path') or (s='directory') or (s='folder') then result:=getCurrentDir
    else if s='short' then result:=fileShortName(sr)
    else if (s='drive') or (s='volume') then result:=getCurrentDrive
    else if s='exists' then result:=1
    else if (s='nameonly') or (s='prefix') then begin
      result:=ExtractFileName(sr.Name);
      i:=lastIndexOf(ExtractFileExt(result),result);
      if i>0 then result:=copy(result,1,i);
    end else if (s='ext') or (s='extension') then begin
      result:=ExtractFileExt(sr.Name);
      result:=copy(result,2,length(result)-1);
    end else if s='short' then result:=sr.Name
    else if s='crc32' then result:=fileCRC32(sr.Name)
    else if s='owner' then result:=fileOwner(ExpandFileName(sr.Name))
    else if s='findexe' then result:=findExe(ExpandFileName(sr.Name))
    else if s='version' then result:=fileVersion(ExpandFileName(sr.Name))
    else if s='index' then begin
      s:=LowerCase(name);
      if ExtractFilePath(s)=IncludeTrailingBackSlash(LowerCase(getCurrentDir)) then s:=ExtractFileName(s);
      result:=-1;
      for i:=0 to UBound(local) do
        if s=LowerCase(local[i]) then begin
          result:=i;
          break;
        end;
    end else if s='search' then
      if readChar='(' then result:=fileScan(sr.name,VarToStr(readExp))
      else log_('<expected ''('''+atline)
    else col:=j;
  end else result:=name;
  FindClose(sr);
end;

procedure TFrmMain.getRemoteFiles(const wildcard:shortstring='');
var
  l:TListBox;
  i:integer;
  t:variant;
begin
  remote:=varEmpty;
  if not FTP.Connected then exit;
  l:=TListBox.Create(self);
  l.Visible:=false;
  l.Parent:=self;
  FTP.List(l.Items,wildcard);
  if l.Count>=1 then remote:=VarArrayCreate([0,l.Count-1],varVariant);
  t:=VarArrayCreate([0,fiMAX],varVariant);
  for i:=0 to l.Count-1 do begin
    t[fiNAME]:=trim(System.Copy(l.Items[i],60,254));
    t[fiSIZE]:=StrToInt(System.Copy(l.Items[i],30,16));
    t[fiAGE ]:=System.Copy(l.Items[i],47,12);
    t[fiATTR]:=System.Copy(l.Items[i],1,10);
    t[fiNODE]:=System.Copy(l.Items[i],11,4);
    t[fiOWNER]:=System.Copy(l.Items[i],15,6);
    t[fiGROUP]:=System.Copy(l.Items[i],21,9);
    remote[i]:=t;
  end;
end;

procedure TFrmMain.blockPush(var block:variant; n:integer);
var tmp:variant;
begin
  if VarIsArray(block) then VarArrayRedim(block,UBound(block)+1)
  else block:=VarArrayCreate([0,0],varVariant);
  tmp:=varArrayCreate([0,0],varVariant);
  tmp[0]:=n;
  block[UBound(block)]:=tmp;
end;

procedure TFrmMain.blockPop(var block:variant);
begin
  if not VarIsArray(block) then exit;
  if UBound(block)>0
  then VarArrayRedim(block,UBound(block)-1)
  else block:=null;
end;

procedure TFrmMain.blockAppend(var block:variant; index:integer; n:variant);
var tmp:variant;
begin
  if not VarIsArray(block) then exit;
  tmp:=UBound(block);
  if index=-1 then index:=tmp else if index>tmp then exit;
  tmp:=block[index];
  VarArrayRedim(tmp,UBound(tmp)+1);
  tmp[UBound(tmp)]:=n;
  block[index]:=tmp;
end;

function  TFrmMain.blockAt(row:integer):variant;
var i:integer;
begin
  result:=Null;
  for i:=0 to UBound(blocks) do
    if blocks[i][blROW]=row then begin
      result:=blocks[i];
      exit;
    end; 
end;

procedure TFrmMain.scan;
var
  a:string;
  i,j:longint;
  c:char absolute i;
  list:TStringList;
  includestack,t:variant;

  function  topsgn:longint;
  begin
    if not VarIsArray(blockstack) then result:=-1
    else result:=blockstack[UBound(blockstack)][blSIGN];
  end;

  function  blocksindex:longint; {returns the index of blocks[] whose [1]=blockstack[last][1]}
  var i,j:longint;
  begin
    result:=-1;
    if VarIsArray(blocks) and VarIsArray(blockstack) then else exit;
    j:=blockstack[UBound(blockstack)][blROW];
    for i:=0 to UBound(blocks) do
      if VarIsArray(blocks) then
        if blocks[i][blROW]=j then begin
          result:=i;
          exit;
        end;
  end;

begin {.scan}
  if not fileExists(scriptname) then exit; 
  includestack:=null;
  t:=varArrayCreate([0,incSTART],varVariant);
  t[incFILENAME]:=LowerCase(scriptname);
  t[incEXITLINE]:=script.Count;
  t[incSTART]:=integer(0);
  includes:=varArrayOf(t);
  blocks:=null;
  fatal:='';
  multirem:=-1;
  row:=-1;
  repeat
    col:=1; inc(row);
    StatusBar.Panels[1].Text:='scan:'+IntToStr(row+1); StatusBar.Refresh;
    while varIsArray(includestack) do
      if row=includestack[UBound(includestack)][incEXITLINE] then blockPop(includestack) else break;
    if row>=script.Count then break;
    if not readComment then continue;
    a:=LowerCase(readChunk);
    if nextChar=':' then begin
      vars.Add(a,row,vtCONSTANT);
      a:=LowerCase(readMethodName);
    end;
    if a='if' then begin
      blockPush(blockstack,sgnIF);
      blockAppend(blockstack,-1,row);
      blockPush(blocks,sgnIF);
      blockAppend(blocks,-1,row);
    end else if (a='elseif') or (a='else_if') or (a='elseifnot') or (a='else_if_not') or (a='else') then begin
      j:=0;
      if (topsgn<>sgnIF) then j:=1 else
        for i:=ifBRANCH to UBound(blockstack[UBound(blockstack)]) do
          if blockstack[UBound(blockstack)][i]<0 then begin
            j:=1;
            break;
          end;
      i:=blocksindex;
      if i=-1 then fatal:='<fatal: '''+a+''' without ''if'''+atline
      else if j<>0 then fatal:='<fatal: '''+a+''' after ''else'''+atline;
      if fatal<>'' then begin
        log_(fatal);
        exit;
      end;
      if a='else' then j:=-row else j:=row;
      blockAppend(blocks,i,j);
    end else if (a='endif') or (a='end_if') then begin
      i:=blocksindex;
      if (topsgn<>sgnIF) or (i=-1) then begin
        fatal:='<fatal: ''endif'' without ''if'''+atline;
        log_(fatal);
        exit;
      end;
      blockAppend(blocks,i,row);
      blockPop(blockstack);
    end else if a='while' then begin
      blockPush(blockstack,sgnWHILE);
      blockAppend(blockstack,-1,row);
      blockPush(blocks,sgnWHILE);
      blockAppend(blocks,-1,row);
      blockAppend(blocks,-1,col);
    end else if (a='endwhile') or (a='end_while') or (a='loop') then begin
      i:=blocksindex;
      if (topsgn<>sgnWHILE) or (i=-1) then begin
        fatal:='<fatal: '''+a+''' without ''while'''+atline;
        log_(fatal);
        exit;
      end;
      blockAppend(blocks,i,row);
      blockPop(blockstack);
    end else if a='repeat' then begin
      blockPush(blockstack,sgnREPEAT);
      blockAppend(blockstack,-1,row);
      blockPush(blocks,sgnREPEAT);
      blockAppend(blocks,-1,row);
    end else if (a='until') or (a='endrepeat') or (a='end_repeat') then begin
      i:=blocksindex;
      if (topsgn<>sgnREPEAT) or (i=-1) then begin
        fatal:='<fatal: '''+a+''' without ''repeat'''+atline;
        log_(fatal);
        exit;
      end;
      blockAppend(blocks,i,row);
      blockPop(blockstack);
    end else if a='for' then begin
      blockPush(blockstack,sgnFOR);
      blockAppend(blockstack,-1,row);
      blockPush(blocks,sgnFOR);
      blockAppend(blocks,-1,row);
      skipFragment;
      blockAppend(blocks,-1,col);
      skipFragment;
      blockAppend(blocks,-1,col);
    end else if (a='endfor') or (a='end_for') or (a='next') then begin
      i:=blocksindex;
      if (topsgn<>sgnFOR) or (i=-1) then begin
        fatal:='<fatal: ''endfor'' without ''for'''+atline;
        log_(fatal);
        exit;
      end;
      blockAppend(blocks,i,row);
      blockPop(blockstack);
    end else if (a='func') or (a='function') then begin
      if VarIsArray(blockstack) then begin
        log_('<fatal: ''func'' inside '''+tabBlock[integer(blockstack[0][blSIGN])]+'...'+tabBlockEnd[integer(blockstack[0][blSIGN])]+''' block'+atline);
        exit;
      end;
      blockPush(blockstack,sgnFUNC);
      blockAppend(blockstack,-1,row);
      blockPush(blocks,sgnFUNC);
      blockAppend(blocks,-1,row);
      a:=VarToStr(readChunk);
      blockAppend(blocks,-1,a);
      vars.Add(a,'',vtFUNCTION);
      skipWhiteSpace;
      if readChar='(' then begin
        repeat
          blockAppend(blocks,-1,readExpression(9));
          skipWhiteSpace;
          if nextChar='=' then begin
            readChar;
            blockAppend(blocks,-1,readExpression(1))
          end else blockAppend(blocks,-1,'');
          skipWhiteSpace;
        until readChar in [#0,')'];
      end;
    end else if (a='endfunc') or (a='end_func') or (a='endfunction') or (a='end_function') then begin
      i:=blocksindex;
      if (topsgn<>sgnFUNC) or (i=-1) then begin
        fatal:='<fatal: unexpected '''+a+''''+atline;
        log_(fatal);
        exit;
      end;
      blockAppend(blocks,i,row);
      vars.StripTo(blocks[i][blFUNC]);
      blockPop(blockstack);
    end else if a='return' then begin
      j:=0;
      for i:=UBound(blockstack) downto 0 do
        if blockstack[i][blSIGN]=sgnFUNC then begin
          j:=1;
          break;
        end;
      if j=0 then begin
        fatal:='<fatal: ''return'' outside of function '+atline;
        log_(fatal);
        exit;
      end;
    end else if a='include' then begin
      skipWhiteSpace; j:=col; a:='';
      while not(nextChar in [#0,#9,' ']) do a:=a+readChar;
      if not fileExists(a) then begin
        col:=j;
        a:=LowerCase(VarToStr(readExp));
      end;
      if fileExists(a) then begin
        list:=TStringList.Create;
        list.LoadFromFile(a);
        script.Delete(row);
        for i:=0 to UBound(includestack) do begin
          t:=includestack[i];
          t[incEXITLINE]:=t[incEXITLINE]+list.Count-1;
          if t[incFILENAME]=a then begin
            fatal:='<fatal: circular include reference'+atline;
            log_(fatal);
            exit;
          end else includestack[i]:=t;
        end;
        for i:=0 to list.Count-1 do
          script.Insert(row+i,list[i]);
        t[incFILENAME]:=a; t[incEXITLINE]:=row+list.Count;
        list.Destroy;
        i:=UBound(includestack)+1;
        if VarIsArray(includestack) then VarArrayRedim(includestack,i)
        else includestack:=VarArrayCreate([0,0],varVariant);
        includestack[i]:=t;
        t[incSTART]:=row;
        i:=UBound(includes)+1;
        varArrayRedim(includes,i);
        includes[i]:=t;
        dec(row);
      end else begin
        col:=j;
        fatal:='<fatal: included file does not exist - '''+a+''''+atline;
        log_(fatal);
        exit;
      end;
    end;
  until false;
  if VarIsArray(blockstack) then
    for i:=UBound(blockstack) downto 0 do begin
      j:=blockstack[i][blSIGN];
      if (j<1) or (j>sgnMAX) then j:=0;
      fatal:='<fatal: unresolved '''+tabBlock[j]+'''...'''+tabBlockEnd[j]+''' structure (from line '+IntToStr(blockstack[i][blROW])+') at end of the script>';
      log_(fatal);
    end;
  if VarIsArray(includestack) then begin
    fatal:='<warning: unresolved inclusion of file '''+includestack[0][incFILENAME]+''''+atline;
    log_(fatal);
  end;
  blockstack:=null;
  includestack:=null;
end;  {.scan}

Function TFrmMain.isFunction(id:string):boolean;
var i:longint;
begin
  result:=false;
  for i:=0 to UBound(blocks) do
    if blocks[i][blSIGN]=sgnFUNC then
      if blocks[i][blFUNC]=id then begin
        result:=true;
        exit;
      end;
end;

Function TFrmMain.atline:ShortString;
var i,max:integer;
begin
  max:=UBound(includes);
  result:=', line '+IntToStr(row+1)+', column '+IntToStr(col)+'>';
  if max>=1 then
    for i:=max downto 1 do
      if (row>=includes[i][incSTART]) and (row<includes[i][incEXITLINE]) then begin
        result:=', line '+IntToStr(row+1)+' (line '+IntToStr(row+1-includes[i][incSTART])+' in "'+includes[i][incFILENAME]+'"), column '+IntToStr(col)+'>';
        break;
      end;
end;

{$R *.DFM}

procedure TFrmMain.MenuItemHorizontalScrollerClick(Sender: TObject);
begin
  with OutputListBox do
    if ScrollWidth=0 then ScrollWidth:=hscroll else ScrollWidth:=0;
end;

procedure TFrmMain.MenuItemEscapeQuitsClick(Sender: TObject);
begin
  escquits:=MenuItemEscapeQuits.Checked;
end;

procedure TFrmMain.MenuItemRestartClick(Sender: TObject);
begin
  FormActivate(nil);
end;

procedure TFrmMain.MenuItemShowErrorsClick(Sender: TObject);
begin
  with StatusBar.Panels[0] do if Bevel=pbLowered then Bevel:=pbRaised else if Bevel=pbRaised then Bevel:=pbLowered;
  DebugListBox.Visible:=not DebugListBox.Visible;
  OutputListBox.Visible:=not OutputListBox.Visible;
  with MenuItemShowErrors do Checked:=not Checked; 
end;

procedure TFrmMain.MenuItemClearClick(Sender: TObject);
begin
  OutputListbox.Clear;
end;

procedure TFrmMain.MenuItemSaveToFileClick(Sender: TObject);
begin
  if not SaveDialog.Execute then exit;
  if StatusBar.Panels[sbpERRORS].Bevel=pbLowered then
    DebugListBox.Items.SaveToFile(SaveDialog.FileName) else
    OutputListBox.Items.SaveToFile(SaveDialog.FileName);
end;

procedure TFrmMain.StatusBarClick(Sender: TObject);
begin
  with StatusBar.Panels[sbpERRORS] do
    MenuItemShowErrorsClick(nil);
end;

procedure TFrmMain.log(const s:string);
var n:integer;
begin
  with OutputListBox do begin
    if Items.Count<logCAPACITY then Items.Append(s) else Items[Items.Count-1]:='<unable to add more logs>';
    n:=Canvas.TextWidth(Items[Items.Count-1]);
    if n>hscroll then hscroll:=n;
  end;
end;

procedure TFrmMain.log_(const s:string);
begin
  with DebugListBox do
    if Items.Count<logCAPACITY then Items.Append(s) else Items.Strings[Items.Count-1]:='<unable to add more logs>';
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  DragAcceptFiles(Handle,True);
  if not dragged then scriptname:=paramstr(1);

  Script:=TStringList.Create;
  if not FileExists(scriptname) then begin
    log('<no script loaded>');
    exit;
  end else Script.LoadFromFile(scriptname);
  vars:=TVarTable.Create;
  vars.Add('false',0,vtCONSTANT);
  vars.Add('true',1,vtCONSTANT);
  autoclose:=false;
  escquits:=true;
  logfollow:=true;
  timewatch:=twUNUSED; timestart:=now;
  scriptStart:=now; scriptEnd:=0;
  ftpcfg:=varArrayCreate([0,FTP_CFG_MAX],varVariant);
  ftpcfg[FTP_SHOW_PASSWORD]:=false;
  ftpcfg[FTP_PATH]:='/';
  ftpcfg[FTP_BYTES_READ]:=0;
  ftpcfg[FTP_BYTES_WRITTEN]:=0;
  ftpcfg[FTP_RECV]:='';
  ftpcfg[FTP_SENT]:='';
  ftpcfg[FTP_STATUS]:='disconnected';
  ftpcfg[FTP_STATUS_CODE]:=hsDisconnected;
  IdLogDebug.Active:=true;
  sDecimal;
  reg:=TRegistry.Create;
  getLocalFiles;
end;  {.FormCreate}

procedure TFrmMain.FormActivate(Sender: TObject);
begin
  with OutputListBox do begin Items.Clear; Visible:=true; end;
  with DebugListBox do begin Items.Clear; Visible:=false; end;
  StatusBar.Panels[sbpERRORS].Bevel:=pbNone;
  scan;
  if fatal<>'' then begin
    if DebugListBox.Items.Count<>0 then begin
      MenuItemShowErrors.Enabled:=true;
      StatusBar.Panels[sbpERRORS].Bevel:=pbRaised;
    end;
    exit;
  end;
  multirem:=-1;
  hscroll:=0;
  row:=-1;
  timewatch:=twUNUSED;
  Run;
end;  {.FormActivate}

procedure TFrmMain.Run;
begin
  repeat
    inc(row);
    StatusBar.Panels[1].Text:=IntToStr(row+1);
    processRow;
    if logfollow then with OutputListBox do TopIndex:=Count-Height div ItemHeight;
    Application.ProcessMessages;
  until row>=script.Count;
  if VarIsArray(blockstack) then begin
    fatal:='<fatal: unresolved structure at the end of the script>';
    log_(fatal);
  end;
  if multirem<>-1 then log_('<warning: unresolved multi-line comment (from line '+IntToStr(multirem)+') in the end of the script>');
  if (copy(fatal,1,5)='<halt') or autoclose then Close;
  Caption:=Caption+' finished';
  if DebugListBox.Items.Count>0 then begin
    MenuItemShowErrors.Enabled:=true;
    StatusBar.Panels[sbpERRORS].Bevel:=pbRaised;
  end;
end;  {.Run}

procedure TFrmMain.processLine(const s:string);
var x,y:integer;
begin
  x:=col; y:=row;
  col:=1; row:=script.Count;
  script.Append(s);
  processStatement;
  script.Delete(row);
  col:=x; row:=y;
end;  {.processLine}

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  with FTP do
  if Connected then begin
    Abort;
    Quit;
    while Connected do Application.ProcessMessages;
  end;
  with FileMapping do if HMap<>0 then CloseHandle(HMap);
end;

procedure TFrmMain.closeFiles;
var fileshand:PFileNode;
begin
  while files<>nil do begin
    fileshand:=files^.next;
    dispose(files);
    files:=fileshand;
  end;
end;

procedure TFrmMain.FormDestroy(Sender:TObject);
begin
  DragAcceptFiles(Handle,false);
  closeFiles;
end;

procedure TFrmMain.OutputListBoxKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#27 then if escquits then begin
    while VarIsArray(blockstack) do blockPop(blockstack);
    row:=script.Count;
    Close;
  end
end;

procedure TFrmMain.TimerTimer(Sender: TObject);
begin
  Application.ProcessMessages;
  if (scriptEnd>0) and (now>=scriptEnd) then begin
    while VarIsArray(blockstack) do blockPop(blockstack);
    row:=script.Count;
    Close;
  end;
end;

procedure TFrmMain.WMDropFiles(var m:TWMDropFiles);
var
  i,n:integer;
  buf:array[0..MAX_PATH] of Char; // buffer na jmeno souboru
begin
  if not isFunction('dropfile') then exit;
  n:=DragQueryFile(m.Drop,$FFFFFFFF,buf,SizeOf(buf));
  for i:=0 to pred(n) do begin
    DragQueryFile(m.Drop,i,buf,SizeOf(buf));
    processLine('dropfile('''+buf+''')');
  end;
  DragFinish(m.Drop);
end;

procedure TFrmMain.WMTimeChange(var Msg:TMessage);
begin
  inherited;
  if isFunction('timechange') then processLine('timechange()');
end;

procedure TFrmMain.WMClipBoardChange(var Message:TMessage);
begin
  if isFunction('clipboardchange') then processLine('clipboardchange()');
end;

procedure TFrmMain.WndMove(var msg:TMessage);
begin
  if isFunction('wndmove') then processLine('wndmove('+IntToStr(longrec(Msg.LParam).lo)+COMMACHAR+IntToStr(longrec(Msg.LParam).hi)+')');
end;

procedure TFrmMain.WMDeviceChange(var Msg:TMessage);
const
  CD_IN =$8000;
  CD_OUT=$8004;
begin
 inherited;
 if isFunction('devicechange') then processLine('devicechange('+IntToStr(Msg.WParam)+')')
end;

procedure TFrmMain.WMDisplayChange(var Msg:TWMDisplayChange);
begin
  inherited;
  if isFunction('displaychange') then processLine('displaychange('+intToStr(Msg.Width)+COMMACHAR+intToStr(Msg.Height)+COMMACHAR+intToStr(Msg.BitsPerPixel)+')');
end;

procedure TFrmMain.FTPConnected(Sender: TObject);
begin
  ftpcfg[FTP_CONNECTED]:=true;
  ftpcfg[FTP_PATH]:='/';
  ftpcfg[FTP_BYTES_READ]:=0;
  ftpcfg[FTP_BYTES_WRITTEN]:=0;
  ftpcfg[FTP_READING]:=false;
  ftpcfg[FTP_WRITING]:=false;
  RefreshStatus;
end;

procedure TFrmMain.FTPDisconnected(Sender: TObject);
begin
  ftpcfg[FTP_CONNECTED]:=false;
  ftpcfg[FTP_PATH]:='';
  ftpcfg[FTP_READING]:=false;
  ftpcfg[FTP_WRITING]:=false;
  RefreshStatus;
end;

procedure TFrmMain.FTPStatus(axSender: TObject; const axStatus: TIdStatus; const asStatusText: String);
begin
  ftpcfg[FTP_STATUS]:=asStatusText;
  ftpcfg[FTP_STATUS_CODE]:=axStatus;
  RefreshStatus;
end;

procedure TFrmMain.RefreshStatus;
var s:string;
begin
  if varAsType(ftpcfg[FTP_CONNECTED],varBoolean) then s:='' else s:='dis';
  s:=s+'connected, status = '+VarAsType(ftpcfg[FTP_STATUS_CODE],VarString)+' - '+ftpcfg[FTP_STATUS];
  StatusBar.Panels[sbpFTP].Text:=s;
  Application.ProcessMessages;
end;

procedure TFrmMain.FTPWorkBegin(Sender:TObject; AWorkMode:TWorkMode; const AWorkCountMax:Integer);
begin
  if AWorkMode=wmRead then ftpcfg[FTP_READING]:=true
  else ftpcfg[FTP_WRITING]:=true
end;

procedure TFrmMain.FTPWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
  if AWorkMode=wmRead then ftpcfg[FTP_READING]:=false
  else ftpcfg[FTP_WRITING]:=false
end;

procedure TFrmMain.FTPWork(Sender: TObject; AWorkMode: TWorkMode; const AWorkCount: Integer);
begin
  if AWorkMode=wmRead then ftpcfg[FTP_BYTES_READ]:=ftpcfg[FTP_BYTES_READ]+AWorkCount
  else ftpcfg[FTP_BYTES_WRITTEN]:=ftpcfg[FTP_BYTES_WRITTEN]+AWorkCount;
end;

procedure TFrmMain.IdLogDebugLogItem(ASender: TComponent; var AText: String);
var mode:integer;
begin
  if System.Copy(AText,1,6)='Sent: ' then mode:=FTP_SENT else mode:=FTP_RECV;
  if IdLogDebug.Tag=mode then ftpcfg[mode]:=ftpcfg[mode]+AText
  else ftpcfg[mode]:=AText;
  IdLogDebug.Tag:=mode;
end;

procedure TFrmMain.skipWhitespace;
begin
  if (row<0) or (row>=script.Count) then exit;
  repeat
    if (col<1) or (col>length(script[row])) then exit;
    if script[row][col] in [#9,' '] then readChar else break;
  until false;
end;

procedure TFrmMain.skipFragment;
var c:char;
begin
  c:=#0;
  repeat
    case readChar of
    '''': if c<>'"' then
            if c='''' then c:=#0 else c:='''';
    '"':  if c<>'''' then
            if c='"' then c:=#0 else c:='"';
    ';','$','@','`','{','}',#1..#31,#127..#255:
          if c=#0 then break;
    #0:   break;
    end;
  until false;
end;

function  TFrmMain.nextChar:char;
begin
  result:=#0;
  if (row<0) or (row>=script.Count) then exit;
  if (col<1) or (col>length(script[row])) then exit;
  result:=script[row][col];
end;

function  TFrmMain.readChar:char;
begin
  result:=nextChar;
  inc(col);
end;

function  TFrmMain.readChunk:string;
begin
  result:='';
  skipWhiteSpace;
  while nextChar in CHUNKCHARS do
    result:=result+readChar;
  skipWhiteSpace;
end;

function  TFrmMain.readMethodName:string;
begin
  readChar;
  result:=readChunk;
end;

function  TFrmMain.readTernarOperator(c:variant):variant;
var a,b:variant;
begin
  a:=readExpression(1);
  skipWhiteSpace;
  if readChar<>'?' then log_('<expected ''?'' in ternar operator'+atline);
  b:=readExpression(1);
  result:=b;
  if varAsType(c,varBoolean) then result:=a;
end;

function  TFrmMain.readAssignment(const key:string):boolean;
var
  v,index:variant;
  d,e:char;
  i:integer;
begin
  e:=readChar; i:=-1;
  v:=vars.Item(key);
  if e=ARRAYCHAR then begin index:=readExp; e:=readChar; end else index:=Null;
  if e='=' then i:=vars.Assign(key,readExpression,index)
  else if e in ['+','-','*','/','%','&','|','<','>',':','!','~'] then begin
    d:=readChar;
    case d of
    '=': if e in ['+','-','*','/','%','&','|',CONCATCHAR,'!','~'] then i:=vars.Assign(key,arithmetic(v,e,readExpression),index);
    '+': if e='+' then i:=vars.Assign(key,arithmetic(v,'+',1),index);
    '-': if e='-' then i:=vars.Assign(key,arithmetic(v,'-',1),index);
    '&': if e='&' then if readChar='=' then i:=vars.Assign(key,arithmetic(v,'&',readExpression),index);
    '|': if e='|' then if readChar='=' then i:=vars.Assign(key,arithmetic(v,'|',readExpression),index);
    '<': 
      case e of
      '<': if readChar='=' then i:=vars.Assign(key,arithmetic(v,'<',readExpression),index);
      ':': if readChar='=' then i:=vars.Assign(key,arithmetic(v,'{',readExpression),index);
      end;
    '>':
      case e of
      '>':
        case readChar of
        '=': i:=vars.Assign(key,arithmetic(v,'>',readExpression),index);
        '>': if readChar='=' then i:=vars.Assign(key,arithmetic(v,')',readExpression),index);
        end;
      ':': if readChar='=' then i:=vars.Assign(key,arithmetic(v,'}',1),index);
      end;
    end;
    if i<0 then log_('<error assigning value to '''+key+''''+atline);
  end else log_('<unknown variable operation'+atline);
  result:=i>=0;
end;

function  TFrmMain.readFunction(funcid:string):variant;
var i,j:integer;
begin
  result:=''; j:=-1;
  for i:=0 to UBound(blocks) do
    if blocks[i][blSIGN]=sgnFUNC then if blocks[i][blFUNC]=funcid then begin
      j:=i;
      break;
    end;
  if j=-1 then exit;
  readChar;
  vars.Add(funcid,'');
  for i:=0 to UBound(blocks[j]) div 2-2 do begin
    skipWhiteSpace;
    if nextChar in [#0,COMMACHAR,')'] then begin
      vars.Add(blocks[j][i*2+3],blocks[j][i*2+4]);
      dec(col);
    end else vars.Add(blocks[j][i*2+3],readExpression);
    readChar;
  end;
  vars.SetAttr(funcid,vtFUNCTION);
  blockPush(blockstack,sgnFUNC);
  blockAppend(blockstack,-1,row);
  blockAppend(blockstack,-1,col);
  blockAppend(blockstack,-1,j);
  i:=row;
  row:=blocks[j][blROW];
  repeat
    inc(row); Caption:=scriptname+' ('+IntToStr(i)+'->'+IntToStr(row)+')';
    processRow;
    Application.ProcessMessages;
  until row>=blocks[j][UBound(blocks[j])];
  result:=vars.Item(funcid);
  vars.StripTo(funcid);
  j:=UBound(blockstack);
  while (j>=0) and (blockstack[j][blSIGN]<>sgnFUNC) do begin
    blockPop(blockstack);
    dec(j);
  end;
  col:=blockstack[j][blCOL];
  row:=blockstack[j][blROW];
  blockPop(blockstack);
end;  {readFunction}

function  TFrmMain.readStructure(a:variant):variant;
var b:variant;
begin
  result:=a;
  b:=col;
  inc(col);
  if nextChar='{' then begin
    readChar;
    a:=readExp;
    if VarIsNumeric(a) then
      result:=copy(VarToStr(result),integer(varAsType(a,varInteger))+1,1);
    exit;
  end;
  if not(nextChar in IDENTIFIERCHAR) then begin
    dec(col);
    exit;
  end;
  a:=LowerCase(readChunk);
  if a='length' then
    result:=length(VarToStr(result))
  else if a='len' then
    if VarIsNumeric(result) then
      if Abs(result)<1 then result:=1
      else result:=trunc(ln(10*Abs(varAsType(result,varDouble)))/ln(10))
    else result:=length(VarToStr(result))
  else if a='abs' then
    if VarIsNumeric(result) then result:=abs(varAsType(result,varDouble))
    else
  else if a='min' then begin
    readChar;
    repeat
      a:=readExp;
      if a<result then result:=a;
      dec(col);
    until readChar in [#0,')'];
  end else if a='max' then begin
    readChar;
    repeat
      a:=readExp;
      if a>result then result:=a;
      dec(col);
    until readChar in [#0,')'];
  end else if (a='uppercase') or (a='ucase') or (a='strtoupper') then result:=UpperCase(VarToStr(result))
  else if (a='lowercase') or (a='lcase') or (a='strtolower') then result:=LowerCase(VarToStr(result))
  else if a='capitalize' then result:=UpCaseFirst(VarToStr(result))
  else if (a='invcase') or (a='icase') or (a='invertedcase') then result:=invertedCase(VarToStr(result))
  else if (a='reverse') or (a='strrev') then result:=str_reverse(VarToStr(result))
  else if a='isdate' then result:=integer(isDate(result))
  else if a='isarray' then result:=integer(VarIsArray(result))
  else if a='isidentifier' then result:=integer(IsValidIdent(result))
  else if a='isset' then result:=integer(vars.Exists(result))
  else if a='isnull' then result:=integer(VarType(result)=varNull)
  else if a='isempty' then result:=integer(VarType(result)=varEmpty)
  else if a='isnumeric' then result:=integer(VarIsNumeric(result))
  else if a='type' then result:=varType(a)
  else if (a='arraysize') or (a='count') then if VarIsArray(result) then result:=UBound(result) shr 1 else result:=-1
  else if a='ubound' then result:=pred(UBound(result) shr 1)
  else if a='key' then begin
    readChar;
    b:=makeNumeric(readExp);
    if (b>=0) and (b<UBound(result) shr 1) then result:=result[b shl 1+1] else result:=Null
  end else if a='bin' then begin
    readChar;
    b:=readExp;
    result:=int2chr(result,b);
  end else if a='indexof' then begin
    readChar;
    a:=readExp;
    result:=pos(VarToStr(a),VarToStr(result))-1;
  end else if (a='lastindexof') or (a='indexofr') then begin
    readChar;
    a:=readExp;
    result:=lastIndexOf(VarToStr(a),VarToStr(result));
  end else if a='charat' then begin
    readChar;
    a:=readExp;
    if not VarIsNumeric(a) then begin
      result:=#0;
      exit;
    end;
    a:=varAsType(a,varInteger);
    if (a<0) or (a>=length(result)) then result:=#0
    else result:=copy(VarToStr(result),integer(a)+1,1);
  end else if a='charcodeat' then begin
    readChar;
    a:=readExp;
    if not VarIsNumeric(a) then begin
      result:=-1;
      exit;
    end;
    a:=varAsType(a,varInteger);
    if (a<0) or (a>=length(result)) then result:=-1
    else result:=ord(VarToStr(result)[integer(a)+1]);
  end else if (a='charcode') or (a='ord') then
    if length(VarToStr(result))=0 then result:=-1
    else result:=ord(VarToStr(result)[1])
  else if a='substr' then begin
    readChar;
    a:=readExpression;
    if readChar=')' then b:=length(VarToStr(result)) else b:=readExp;
    if VarIsNumeric(a) and VarIsNumeric(b)
    then result:=copy(VarToStr(result),integer(varAsType(a,varInteger))+1,integer(varAsType(b,varInteger)))
    else result:='';
  end else if a='substring' then begin
    readChar;
    a:=readExp;
    a:=readExpression;
    if readChar=')' then b:=length(VarToStr(result)) else b:=readExp;
    if VarIsNumeric(a) and VarIsNumeric(b)
    then result:=copy(VarToStr(result),round(a+1),round(a+1+b))
    else result:='';
  end else if a='left' then begin
    readChar;
    a:=readExp;
    if VarIsNumeric(a)
    then result:=copy(VarToStr(result),1,round(a))
    else result:='';
  end else if a='right' then begin
    readChar;
    a:=readExp;
    result:=VarToStr(result);
    if VarIsNumeric(a)
    then result:=RightStr(result,round(a))
    else result:='';
  end else if (a='begins') or (a='beginswith') then begin
    readChar;
    a:=VarToStr(readExp); b:=length(a);
    if copy(VarToStr(a),1,integer(b))=copy(VarToStr(result),1,integer(b)) then result:=1 else result:=0;
  end else if (a='ends') or (a='endswith') then begin
    readChar;
    a:=VarToStr(readExp); b:=length(a);
    if RightStr(a,b)=RightStr(result,b) then result:=1 else result:=0;
  end else if a='contains' then begin
    readChar;
    result:=integer(Pos(VarToStr(readExp),result)>0);
  end else if a='insert' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    if VarIsNumeric(a) then begin
      a:=round(a);
      if a>=0 then result:=System.copy(VarToStr(result),1,integer(a))+VarToStr(b)+System.Copy(VarToStr(result),integer(a)+1,length(VarToStr(result)))
    end else result:='';
  end else if a='stuff' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    if VarIsNumeric(a) then begin
      a:=round(a);
      if a>=0 then result:=System.copy(VarToStr(result),1,integer(a))+VarToStr(b)+System.Copy(VarToStr(result),integer(a)+1+length(VarToStr(b)),length(VarToStr(result)))
    end else result:='';
  end else if a='delete' then begin
    readChar;
    a:=readExpression;
    if readChar<>')' then b:=readExp else b:=length(VarToStr(result));
    if VarIsNumeric(a)
    then result:=System.Copy(VarToStr(result),1,integer(VarAsType(a,varInteger)))+System.Copy(VarToStr(result),integer(VarAsType(a,varInteger)+VarAsType(b,varInteger)+1),length(VarToStr(result)))
    else result:='';
  end else if a='replace' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    result:=StringReplace(result,a,b,[rfReplaceAll]);
  end else if a='ireplace' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    result:=StringReplace(result,a,b,[rfReplaceAll,rfIgnoreCase]);
  end else if a='replacefirst' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    result:=StringReplace(result,a,b,[]);
  end else if a='ireplacefirst' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    result:=StringReplace(result,a,b,[rfIgnoreCase]);
  end else if a='empty' then
    if (result='') or (VarType(result) in [varEmpty,varNull]) then result:=1 else result:=0
  else if (a='xlat') or (a='strxlat') or (a='charreplace') or (a='strtr') then begin
    readChar;
    a:=readExp;
    b:=readExp;
    result:=str_xlat(VarToStr(a),VarToStr(b),VarToStr(result));
  end else if a='quote' then begin
    a:='"';
    if nextChar='(' then begin
      readChar;
      a:=VarToStr(readExp);
      repeat until readChar in [#0,')'];
    end;
    result:=a+VarToStr(result)+a;
  end else if a='bit' then begin
    readChar;
    a:=readExp;
    b:=false;
    if VarIsNumeric(a) and VarIsNumeric(result) then begin
      a:=round(a);
      if (a>=0) and (a<=31) then b:=true;
    end;
    if b then result:=round(result) and (1 shl a)
    else result:=0;
  end else if a='bitset' then begin
    readChar;
    a:=readExp;
    b:=false;
    if VarIsNumeric(a) and VarIsNumeric(result) then begin
      a:=round(a);
      if (a>=0) and (a<=63) then b:=true;
    end;
    if b then result:=round(result) or (1 shl a);
  end else if a='bitclear' then begin
    readChar;
    a:=readExp;
    b:=false;
    if VarIsNumeric(a) and VarIsNumeric(result) then begin
      a:=round(a);
      if (a>=0) and (a<=63) then b:=true;
    end;
    if b then result:=round(result) and not(1 shl a);
  end else if a='date' then
    if isDate(result) then
      result:=DateToStr(varAsType(result,varDate))
    else
  else if a='time' then
    if isDate(result) then
      result:=TimeToStr(varAsType(result,varDate))
    else
  else if a='datetime' then
    if isDate(result) then
      result:=DateTimeToStr(varAsType(result,varDate))
    else
  else if a='todatetime' then
    try result:=VarAsType(StrToDateTime(result),varDouble) except end
  else if a='todate' then
    try result:=VarAsType(StrToDate(result),varDouble) except end
  else if a='totime' then
    try result:=VarAsType(StrToTime(result),varDouble) except end
  else if a='msec2dt' then
    if VarIsNumeric(result) then result:=result/DAY_MS else
  else if a='dt2msec' then
    if VarIsNumeric(result) then result:=result*DAY_MS else
  else if a='datepart' then begin
    readChar;
    a:=readExp;
    if isDate(result) then
      if a='' then result:=DateTimeToStr(varAsType(result,varDate))
      else result:=FormatDateTime(VarToStr(a),varAsType(result,varDate));
  end else if (a='stamp') or (a='timestamp') then
    if isDate(result) and not VarIsNumeric(result) then result:=varAsType(StrToDateTime(result),varDouble) else result:=''
  else if a='filedate' then
    if isDate(result) and not VarIsNumeric(result) then result:=DateTimeToFileDate(varAsType(StrToDateTime(result),varDouble)) else result:=''
  else if a='_filedate' then
    if VarIsNumeric(result) then result:=FileDateToDateTime(varAsType(result,varInteger)) else result:=''
  else if a='julian' then
    if isDate(result) and not VarIsNumeric(result) then result:=DateTimeToJulianDate(varAsType(StrToDateTime(result),varDouble)) else result:=''
  else if a='_julian' then
    if isDate(result) and not VarIsNumeric(result) then result:=JulianDateToDateTime(varAsType(StrToDateTime(result),varDouble)) else result:=''
  else if a='julianm' then
    if isDate(result) and not VarIsNumeric(result) then result:=DateTimeToModifiedJulianDate(varAsType(StrToDateTime(result),varDouble)) else result:=''
  else if a='_julianm' then
    if isDate(result) and not VarIsNumeric(result) then result:=ModifiedJulianDateToDateTime(varAsType(StrToDateTime(result),varDouble)) else result:=''
  else if a='unixdate' then
    if isDate(result) and not VarIsNumeric(result) then result:=DateTimeToUnix(varAsType(StrToDateTime(result),varDouble)) else result:=''
  else if a='_unixdate' then
    if VarIsNumeric(result) then result:=UnixToDateTime(varAsType(result,varInt64)) else result:=''
  else if a='inet' then
    if isDate(result) and not VarIsNumeric(result) then result:=DateTimeToInternetStr(varAsType(StrToDateTime(result),varDouble)) else result:=''
  else if a='_inet' then
    result:=StrInternetToDateTime(VarToStr(result))
  else if a='round' then begin  
    if nextChar='(' then begin
      readChar; 
      a:=readExp;
    end;
    if not VarIsNumeric(a) then a:=1;
    if VarIsNumeric(result) then result:=round(varAsType(result,varDouble)/a)*a;
  end else if a='trunc' then
    if VarIsNumeric(result) then result:=trunc(varAsType(result,varDouble))
    else
  else if a='frac' then
    if VarIsNumeric(result) then result:=frac(varAsType(result,varDouble))
    else
  else if (a='random') or (a='rand') or (a='rnd') then
    if VarIsNumeric(result) then result:=random(trunc(varAsType(result,varDouble)))
    else
  else if (a='sign') or (a='sgn') then
    if VarIsNumeric(result) then begin
      if result<0 then result:=-1 else if result>0 then result:=1 else result:=0;
    end else
  else if a='inv' then
    if VarIsNumeric(result) then result:=-varAsType(result,varDouble)
    else
  else if a='neg' then
    if VarIsNumeric(result) then result:=integer(not varAsType(result,varBoolean))
    else
  else if a='bytes' then begin
    if VarIsNumeric(result) then
      if varAsType(result,varDouble)>=1099511627776.0 then result:=VarToStr(trunc(varAsType(result,varDouble)/109951162777.6)/10)+' TB'
      else if varAsType(result,varDouble)>=1073741824.0 then result:=VarToStr(trunc(varAsType(result,varDouble)/107374182.4)/10)+' GB'
      else if varAsType(result,varDouble)>=1048576.0 then result:=VarToStr(trunc(varAsType(result,varDouble)/104857.60)/10)+' MB'
      else if varAsType(result,varDouble)>=1024.0 then result:=VarToStr(trunc(varAsType(result,varDouble)/102.4)/10)+' kB'
      else result:=VarToStr(trunc(varAsType(result,varDouble)))+' B';
  end else if a='rep' then begin
    readChar;
    a:=readExp;
    if VarIsNumeric(a) then
      result:=rep(VarToStr(result),varAsType(a,varInteger));
  end else if (a='str') or (a='tostr') then result:=VarToStr(a)
  else if a='b' then result:=numberTo(result,2)
  else if (a='o') or (a='q') then result:=numberTo(result,8)
  else if a='h' then result:=numberTo(result,16)
  else if a='_b' then result:=numberFrom(result,2)
  else if (a='_o') or (a='_q') then result:=numberFrom(result,8)
  else if a='_h' then result:=numberFrom(result,16)
  else if (a='bool') or (a='boolean') then result:=integer(varAsType(result,varBoolean))
  else if a='swap' then begin
    readChar;
    a:=VarToStr(readExp);
    if vars.Exists(result) and vars.Exists(a) then begin
      b:=vars.Item(a);
      vars.Assign(a,vars.Item(result));
      vars.Assign(result,b)
    end else log_('<couldn''t swap '''+result+''' and '''+a+''''+atline);
  end else if (a='cutstring') or (a='tokenise') then begin
    readChar;
    a:=VarToStr(readExp);
    if vars.Exists(result) then 
      result:=CutString(a,readExp)
    else
  end else if (a='numberfrom') or (a='numn10') then begin
    readChar;
    a:=readExp;
    if VarIsNumeric(a) then
      result:=numberFrom(result,varAsType(a,varInteger));
  end else if (a='numberto') or (a='num10n') then begin
    readChar;
    a:=readExp;
    if VarIsNumeric(a) then
      result:=numberTo(result,varAsType(a,varInteger));
  end else if (a='in') or (a='isin') or (a='inlist') or (a='among') or (a='inlistof') then begin
    readChar;
    a:=0;
    repeat
      b:=readExp;
      if VarToStr(result)=VarToStr(b) then a:=1;
      dec(col);
    until readChar in [#0,')'];
    result:=a;
  end else if a='between' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    if a<b then result:=integer((result>=a) and (result<=b))
    else result:=integer((result>=b) and (result<=a));
  end else if a='bound' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    if a<b then begin
      if result<a then result:=a;
      if result>b then result:=b;
    end else begin
      if result<b then result:=b;
      if result>a then result:=a;
    end;
  end else if a='wrapped' then begin
    readChar;
    a:=readExp;
    b:=readExp;
    if VarIsNumeric(a) and VarIsNumeric(b) and VarIsNumeric(result) then
      result:=wrapped(varAsType(result,varInteger),varAsType(a,varInteger),varAsType(b,varInteger));
  end else if a='trim' then result:=trim(VarToStr(result),trimBOTH)
  else if a='ltrim' then result:=trim(VarToStr(result),trimLEFT)
  else if a='rtrim' then result:=trim(VarToStr(result),trimRIGHT)
  else if a='trailslash' then result:=IncludeTrailingBackSlash(VarToStr(result))
  else if a='pad' then begin
    readChar;
    a:=readExp;
    b:=readExp; if VarToStr(b)='' then b:=' ';
    result:=VarToStr(result);
    if VarIsNumeric(a) then begin
      a:=round(VarAsType(a,varDouble));
      result:=rep(VarToStr(b),a-length(result))+result;
      if length(result)<>a then result:=copy(VarToStr(result),integer(length(result)-a),integer(a));
    end;
  end else if a='urlencode' then begin
    readChar; result:=URLEncode(VarToStr(readExp));
  end else if a='urldecode' then begin
    readChar; result:=URLDecode(VarToStr(readExp));
  end else if a='sqr' then
    if VarIsNumeric(result) then result:=sqr(result) else result:=0
  else if a='sqrt' then
    if VarIsNumeric(result) then result:=sqrt(result) else result:=0
  else if a='sin' then
    if VarIsNumeric(result) then result:=sin(result) else result:=0
  else if a='cos' then
    if VarIsNumeric(result) then result:=cos(result) else result:=0
  else if (a='tg') or (a='tan') then
    if VarIsNumeric(result) then result:=sin(result)/cos(result) else result:=0
  else if (a='arctg') or (a='arctan') then
    if VarIsNumeric(result) then result:=arctan(result) else result:=0
  else if a='ln' then
    if VarIsNumeric(result) then result:=ln(result) else result:=0
  else if a='log10' then
    if VarIsNumeric(result) then result:=ln(result)/ln(10) else result:=0
  else if a='exp' then
    if VarIsNumeric(result) then result:=exp(result) else result:=0
  else if a='th' then
    if VarIsNumeric(result) then begin
      result:=round(abs(result));
      if result mod 100 div 10=1 then result:='th'
      else
        case result mod 10 of
        1: result:='st';
        2: result:='nd';
        3: result:='rd';
        else result:='th';
        end;
    end else
  else if a='nth' then
    if VarIsNumeric(result) then begin
      result:=round(abs(result));
      if result mod 100 div 10=1 then result:=result+'th'
      else
        case result mod 10 of
        1: result:=result+'st';
        2: result:=result+'nd';
        3: result:=result+'rd';
        else result:=result+'th';
        end;
    end else
  else if a='plural' then begin
    readChar;
    a:=readExp;
    if VarIsNumeric(a) then
      if round(abs(a)) mod 1000<>1 then begin
        result:=VarToStr(result)+'s';
        if length(result)>3 then if RightStr(result,2)='ys' then result:=copy(result,1,length(result)-2)+'ies';
      end;
  end else if (a='matches') or (a='regex') then with PerlRegEx do begin
    readChar;
    Subject:=result;
    RegEx:=VarToStr(readExp);
    result:=integer(Match);
  end else if a='hkey2str' then
    result:=HKEY2str(integer(result))
  else begin
    a:=col; col:=b;
    log_('<unrecognized implicit method'+atline);
    col:=a;
  end;
  {*array_push,sort,registry,decodeProductKey}
end;  {.readStructure}

function  TFrmMain.readVariable(a:variant):variant;
  function gki(i:integer):variant;
  var t:TRegKeyInfo; ft:TFileTime;
  begin
    result:=Null;
    if not reg.GetKeyInfo(t) then exit;
    case i of
    gkiKEYS: result:=t.NumSubKeys;
    gkiVALUES: result:=t.NumValues;
    gkiLONGEST: result:=t.MaxDataLen;
    gkiMODIFIED:
      begin
        ft:=t.FileTime;
        result:=ft.dwHighDateTime;
      end;
    end;
  end;
  function arrayIndex(a,index:variant):integer;
  var i,max:integer;
  begin
    result:=-1;
    i:=0; max:=UBound(a);
    while i<=max do
      if VarSameValue(a[i],index) then begin
        result:=i;
        break;
      end else inc(i,2);
  end;
var
  i,j:longint;
  fileshand:PFileNode;
begin {readVariable}
  a:=LowerCase(a);
  if a='local' then repeat
    a:=nextChar;
    if (a<>MEMBERCHAR) and (a<>ARRAYCHAR) then begin
      result:=getCurrentDir;
      exit;
    end;
    readChar;
    if a=ARRAYCHAR then begin
      a:=readExp;
      if VarIsNumeric(a) then begin
        i:=VarAsType(a,varInteger);
        if (i<0) or (i>UBound(local)) then begin
          result:='';
          break;
        end else a:=local[i];
      end;
      result:=getLocalFile(a);
      break;
    end;
    j:=col;
    a:=LowerCase(readChunk);
    if a='driveletter' then result:=GetCurrentDrive
    else if a='diskfree' then result:=DiskFree(0)
    else if a='disksize' then result:=DiskSize(0)
    else if a='drivetypecode' then begin
      i:=ord(GetCurrentDrive);
      if nextChar='(' then i:=str2byte(VarToStr(readExp));
      result:=GetDriveType(PChar(chr(i)+':\'));
      if a='drivetype' then
        case result of
        0: result:='UNDETERMINED';
        1: result:='ROOTLESS';
        DRIVE_REMOVABLE: result:='REMOVABLE';
        DRIVE_FIXED: result:='FIXED';
        DRIVE_REMOTE: result:='REMOTE';
        DRIVE_CDROM: result:='CD-ROM';
        DRIVE_RAMDISK: result:='RAM DISK';
        else result:='UNKNOWN';
        end
    end else if (a='fsname') or (a='filesystem') or (a='fs') then result:=FileSystemName(getCurrentDrive)
    else if (a='volumesn') or (a='serialnumber') then result:=VolumeSerialNumber(getCurrentDrive)
    else if a='dirsize' then
      if nextChar='(' then begin
        readChar;
        result:=dirSize(readExp);
      end else result:=dirSize(getCurrentDir)
    else if a='direxists' then begin
      readChar;
      result:=integer(directoryExists(readExp));
    end else if a='path' then begin
      result:=getCurrentDir;
      col:=j;
    end else if a='findexe' then begin
      readChar;
      result:=string(findExe(readExp));
    end else if a='path_desktop' then result:=getPath(Handle,CSIDL_DESKTOP)
    else if a='path_internet' then result:=getPath(Handle,CSIDL_INTERNET)
    else if a='path_programs' then result:=getPath(Handle,CSIDL_PROGRAMS)
    else if a='path_controls' then result:=getPath(Handle,CSIDL_CONTROLS)
    else if a='path_printers' then result:=getPath(Handle,CSIDL_PRINTERS)
    else if a='path_personal' then result:=getPath(Handle,CSIDL_PERSONAL)
    else if a='path_favorites' then result:=getPath(Handle,CSIDL_FAVORITES)
    else if a='path_startup' then result:=getPath(Handle,CSIDL_STARTUP)
    else if a='path_recent' then result:=getPath(Handle,CSIDL_RECENT)
    else if a='path_sendto' then result:=getPath(Handle,CSIDL_SENDTO)
    else if a='path_bitbucket' then result:=getPath(Handle,CSIDL_BITBUCKET)
    else if a='path_startmenu' then result:=getPath(Handle,CSIDL_STARTMENU)
    else if a='path_desktopdirectory' then result:=getPath(Handle,CSIDL_DESKTOPDIRECTORY)
    else if a='path_drives' then result:=getPath(Handle,CSIDL_DRIVES)
    else if a='path_network' then result:=getPath(Handle,CSIDL_NETWORK)
    else if a='path_nethood' then result:=getPath(Handle,CSIDL_NETHOOD)
    else if a='path_fonts' then result:=getPath(Handle,CSIDL_FONTS)
    else if a='path_templates' then result:=getPath(Handle,CSIDL_TEMPLATES)
    else if a='path_common_startmenu' then result:=getPath(Handle,CSIDL_COMMON_STARTMENU)
    else if a='path_common_programs' then result:=getPath(Handle,CSIDL_COMMON_PROGRAMS)
    else if a='path_common_startup' then result:=getPath(Handle,CSIDL_COMMON_STARTUP)
    else if a='path_common_desktopdirectory' then result:=getPath(Handle,CSIDL_COMMON_DESKTOPDIRECTORY)
    else if a='path_appdata' then result:=getPath(Handle,CSIDL_APPDATA)
    else if a='path_printhood' then result:=getPath(Handle,CSIDL_PRINTHOOD)
    else if a='path_altstartup' then result:=getPath(Handle,CSIDL_ALTSTARTUP)
    else if a='path_common_altstartup' then result:=getPath(Handle,CSIDL_COMMON_ALTSTARTUP)
    else if a='path_common_favorites' then result:=getPath(Handle,CSIDL_COMMON_FAVORITES)
    else if a='path_internet_cache' then result:=getPath(Handle,CSIDL_INTERNET_CACHE)
    else if a='path_cookies' then result:=getPath(Handle,CSIDL_COOKIES)
    else if a='path_history' then result:=getPath(Handle,CSIDL_HISTORY)
    else result:=UBound(local)+1;
  until true else if a='ftp' then begin
    a:=nextChar;
    if (a<>MEMBERCHAR) and (a<>ARRAYCHAR) then begin
      result:='{Host: "'+FTP.Host+'", Port: '+IntToStr(FTP.Port)+', Path: '+ftpcfg[FTP_PATH]+', User: '+FTP.User+', Password: ';
      if ftpcfg[FTP_SHOW_PASSWORD] then result:=result+FTP.Password+'}' else result:=result+'<hidden>}';
      exit;
    end;
    readChar;
    if a=ARRAYCHAR then begin
      a:=readExp;
      if VarIsNumeric(a) then i:=round(varAsType(a,varInteger))
      else i:=fileIndex(VarToStr(a),remote);
      if (i<0) or (i>UBound(remote)) then begin
        result:='';
        exit;
      end;
      if nextChar<>MEMBERCHAR then begin
        result:=remote[i][fiNAME];
        exit;
      end;
      j:=col;
      a:=LowerCase(readMethodName);
      if (a='name') or (a='filename') then result:=remote[i][fiNAME]
      else if a='nameonly' then begin
        result:=ExtractFileName(remote[i][fiNAME]);
        a:=lastIndexOf(ExtractFileExt(result),result);
        if a>0 then result:=copy(result,1,integer(a));
      end else if a='fullname' then result:=ftpcfg[FTP_PATH]+remote[i][fiNAME]
      else if (a='size') or (a='filesize') then result:=remote[i][fiSIZE]
      else if (a='lastwritetime') or (a='lastmodified') or (a='modified') then result:=DateTimeToStr(remote[i][fiLASTWRITETIME])
      else if (a='datetime') or (a='age') then result:=DateTimeToStr(remote[i][fiAGE])
      else if (a='attr') or (a='attributes') then result:=remote[i][fiATTR]
      else if (a='attrdirectory') or (a='dir') or (a='isdir') or (a='directory') then result:=integer(System.Copy(VarToStr(remote[i][fiATTR]),1,1)='d')
      else if a='attrfile' then result:=integer(System.Copy(VarToStr(remote[i][fiATTR]),1,1)<>'-')
      else if a='node' then result:=remote[i][fiNODE]
      else if a='group' then result:=remote[i][fiGROUP]
      else if a='owner' then result:=remote[i][fiOWNER]
      else if a='path' then result:=ftpcfg[FTP_PATH]
      else if (a='ext') or (a='extension') then begin
        result:=ExtractFileExt(remote[i][fiNAME]);
        result:=copy(result,2,length(result)-1);
      end else begin
        result:=remote[i][fiNAME];
        col:=j;
      end;
      exit;
    end;
    a:=LowerCase(readChunk);
    if (a='host') or (a='remotehost') or (a='address') or (a='url') then result:=FTP.Host
    else if a='port' then result:=FTP.Port
    else if (a='password') or (a='pass') or (a='passw') or (a='pwd') then result:=FTP.Password
    else if (a='showpassword') or (a='showpassw') or (a='showpwd') then result:=integer(ftpcfg[FTP_SHOW_PASSWORD])
    else if (a='connected') or (a='online') then result:=integer(FTP.Connected)
    else if (a='closed') or (a='quited') then result:=integer(not FTP.Connected)
    else if a='closedgracefully' then result:=integer(FTP.closedgracefully)
    else if a='ready' then result:=integer(FTP.Connected and not(ftpcfg[FTP_READING] or ftpcfg[FTP_WRITING]))
    else if a='busy' then result:=integer(FTP.Connected and (ftpcfg[FTP_READING] or ftpcfg[FTP_WRITING]))
    else if a='reading' then result:=integer(FTP.Connected and ftpcfg[FTP_READING])
    else if a='writing' then result:=integer(FTP.Connected and ftpcfg[FTP_WRITING])
    else if (a='ip') or (a='boundip') or (a='clientip') then result:=FTP.BoundIP
    else if (a='user') or (a='username') or (a='userid') or (a='uname') then result:=FTP.User
    else if (a='state') or (a='status') then result:=ftpcfg[FTP_STATUS]
    else if (a='statecode') or (a='statuscode') then result:=ftpcfg[FTP_STATUS_CODE]
    else if (a='system') or (a='feat') or (a='systemdesc') then result:=FTP.SystemDesc
    else if (a='recvbuffersize') or (a='recvbufsize') then result:=FTP.RecvBufferSize
    else if (a='sendbuffersize') or (a='sendbufsize') then result:=FTP.SendBufferSize
    else if (a='passive') or (a='pasv') or (a='passivemode') or (a='ispassive') or (a='passive') then result:=integer(FTP.Passive)
    else if (a='binary') or (a='b') then result:=integer(FTP.TransferType=ftBinary)
    else if (a='ascii') or (a='text') then result:=integer(FTP.TransferType=ftASCII)
    else if a='transfertype' then if FTP.TransferType=ftBinary then result:='B' else result:='A'
    else if a='readlnwait' then result:=FTP.ReadLnWait
    else if a='readlntimedout' then result:=integer(FTP.ReadLnTimedOut)
    else if a='recv' then result:=ftpcfg[FTP_RECV]
    else if a='sent' then result:=ftpcfg[FTP_SENT]
    else if a='recvlines' then result:=StringReplace(varToStr(ftpcfg[FTP_RECV]),'<EOL>',EOL,[rfReplaceAll,rfIgnoreCase])
    else if a='sentlines' then result:=StringReplace(varToStr(ftpcfg[FTP_SENT]),'<EOL>',EOL,[rfReplaceAll,rfIgnoreCase])
    else if a='lastdirection' then if IdLogDebug.Tag=FTP_RECV then result:='recv' else result:='sent'
    else if (a='connectandgetall') or (a='connectgetall') then result:=FTP.ConnectAndGetAll
    else if (a='socksauth') or (a='socksauthentication') then result:=integer(FTP.SocksInfo.Authentication)
    else if a='sockshost' then result:=FTP.SocksInfo.Host
    else if a='socksport' then result:=FTP.SocksInfo.Port
    else if (a='sockspwd') or (a='sockspassw') or (a='sockspassword') then result:=FTP.SocksInfo.Password
    else if (a='socksuser') or (a='socksusername') or (a='socksuserid') then result:=FTP.SocksInfo.UserID
    else if (a='nagle') then result:=integer(FTP.UseNagle)
    else if (a='asciifilter') or (a='converttoascii') then result:=integer(FTP.ASCIIFilter)
    else if a='bytesread' then result:=ftpcfg[FTP_BYTES_READ]
    else if a='byteswritten' then result:=ftpcfg[FTP_BYTES_WRITTEN]
    else if a='currentdir' then result:=FTP.RetrieveCurrentDir
    else if a='pop' then begin
      readChar;
      j:=VarAsType(readExp,varInteger);
      result:=FTP.ExtractXBytesFromBuffer(j);
    end else if a='readstring' then
      if nextChar='(' then begin
        j:=VarAsType(readExp,varInteger);
        result:=FTP.ReadString(j);
      end else begin
        a:=FTP.ReadString(1);
        result:=FTP.ReadString(str2byte(a));
      end
    else if (a='readln') or (a='readline') then begin
      a:=varArrayCreate([0,1],varVariant);
      a[0]:=''; a[0]:=-2;
      if nextChar='(' then begin
        readChar; a[0]:=VarToStr(readExpression);
        if nextChar=COMMACHAR then begin
          readChar; a[1]:=readExpression;
          if VarToStr(a[1])='' then a[1]:=-2 else a[1]:=varAsType(a[1],varInteger);
        end;
        readChar;
      end;
      result:=FTP.ReadLn(a[0],a[1]);
    end else if (a='socksver') or (a='socksversion') or (a='version') then
      case integer(FTP.SocksInfo.Version) of
      0: result:=0;
      1: result:='4.0';
      2: result:='4.0A';
      3: result:='5.0';
      else result:=integer(FTP.SocksInfo.Version)
      end
    else if a='inputln' then begin
      if nextChar='(' then begin
        readChar;
        a:=readExp;
      end else a:='';
      result:=FTP.InputLn(a);
    end else if a='path' then result:=ftpcfg[FTP_PATH]
    else result:=UBound(remote)+1
  end else if a='misc' then begin
    if nextChar<>MEMBERCHAR then exit;
    j:=col;
    a:=LowerCase(readMethodName);
    if (a='line') or (a='linenumber') or (a='row') or (a='rownumber') then result:=row
    else if (a='column') or (a='col') then result:=col
    else if a='autoclose' then result:=integer(autoclose)
    else if a='escquits' then result:=integer(escquits)
    else if a='pi' then result:=Pi
    else if a='scriptstart' then result:=scriptStart
    else if a='scriptend' then result:=scriptEnd
    else if (a='ttl') or (a='scriptlife') or (a='timetolive') then
      if scriptEnd=0 then result:=0 else result:=scriptEnd-now
    else if a='concatchar' then result:=CONCATCHAR
    else if a='memberchar' then result:=MEMBERCHAR
    else if a='commachar' then result:=COMMACHAR
    else if a='commentchar' then result:=COMMENTCHAR
    else if a='arraychar' then result:=ARRAYCHAR
    else if a='mem_load' then result:=GlobalMemStatus.dwMemoryLoad
    else if a='mem_phys_total' then result:=GlobalMemStatus.dwTotalPhys
    else if a='mem_phys_avail' then result:=GlobalMemStatus.dwAvailPhys
    else if a='mem_page_total' then result:=GlobalMemStatus.dwTotalPageFile
    else if a='mem_page_avail' then result:=GlobalMemStatus.dwAvailPageFile
    else if a='mem_virt_total' then result:=GlobalMemStatus.dwTotalVirtual
    else if a='mem_virt_avail' then result:=GlobalMemStatus.dwAvailVirtual
    else if a='mem_alloccount' then result:=AllocMemCount
    else if a='mem_allocsize' then result:=AllocMemSize
    else if a='mem_heapallocflags' then result:=HeapAllocFlags
    else if a='mem_free' then result:=AllocMemCount
    else if a='mouse' then result:=integer(Mouse.MousePresent)
    else if a='mouse_buttons' then result:=GetSystemMetrics(SM_CMOUSEBUTTONS)
    else if a='mouse_x' then result:=Mouse.CursorPos.X
    else if a='mouse_y' then result:=Mouse.CursorPos.Y
    else if a='mouse_wheel' then result:=integer(Mouse.WheelPresent)
    else if a='mouse_wheelscroll' then result:=Mouse.WheelScrollLines
    else if a='mouse_cursor' then result:=Screen.Cursor
    else if a='joy_buttons' then result:=joyGetNumDevs
    else if a='win_platform' then result:=Win32Platform
    else if a='win_boot' then result:=GetSystemMetrics(SM_CLEANBOOT)
    else if a='screen_width' then result:=Screen.Width
    else if a='screen_height' then result:=Screen.Height
    else if a='screen_ppi' then result:=Screen.PixelsPerInch
    else if a='screen_monitors' then result:=Screen.MonitorCount
    else if a='screensaver_timeout' then SystemParametersInfo(SPI_GETSCREENSAVETIMEOUT,0,@result,0)
    else if a='screensaver_active' then begin
      SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,@i,0);
      result:=integer(boolean(byte(i)));
    end else if a='systemfontsize' then result:=systemFontSize
    else if a='fonts' then
      if nextChar=ARRAYCHAR then begin
        readChar; a:=readExpression;
        if readChar<>']' then log_('<expected '']'''+atline);
        if VarIsNumeric(a) then result:=screen.Fonts[VarAsType(a,varInteger)];
      end else result:=screen.Fonts.Count
    else if a='privileges' then
      if nextChar=ARRAYCHAR then begin
        readChar; a:=readExpression;
        if readChar<>']' then log_('<expected '']'''+atline);
        i:=VarAsType(a,varInteger);
        if nextChar=MEMBERCHAR then begin
          a:=readMethodName;
          if a='displayname' then result:=CurrentUserPrivileges(i,prvlDISPLAYNAME)
          else if (a='value') or (a='luid') then result:=CurrentUserPrivileges(i,prvlVALUE)
          else if (a='attr') or (a='attributes') then result:=CurrentUserPrivileges(i,prvlATTRIBUTES)
          else result:=CurrentUserPrivileges(i,prvlNAME)
        end else result:=CurrentUserPrivileges(i,prvlNAME)
      end else result:=CurrentUserPrivileges(0,0)
    else if a='printers' then begin
      if nextChar=ARRAYCHAR then begin
        readChar; i:=VarAsType(readExpression,varInteger);
        if readChar<>']' then log_('<expected '']'''+atline);
      end else i:=Printer.PrinterIndex;
      j:=Printer.PrinterIndex; Printer.PrinterIndex:=i;
      if nextChar=MEMBERCHAR then begin
        a:=readMethodName;
        if a='copies' then result:=Printer.Copies
        else if a='orientation' then result:=Printer.Orientation
        else if a='pageheight' then result:=Printer.PageHeight
        else if a='pagewidth' then result:=Printer.PageWidth 
        else if a='pagenumber' then result:=Printer.PageNumber
        else if a='index' then result:=Printer.PrinterIndex
        else if a='printing' then result:=Printer.Printing
        else if a='specversion' then result:=PrinterDeviceMode(i).dmSpecVersion
        else if a='driverversion' then result:=PrinterDeviceMode(i).dmDriverVersion
        else if a='papersize' then result:=PrinterDeviceMode(i).dmPaperSize
        else if a='paperlength' then result:=PrinterDeviceMode(i).dmPaperLength
        else if a='paperwidth' then result:=PrinterDeviceMode(i).dmPaperWidth
        else if (a='printquality') or (a='quality') then result:=PrinterDeviceMode(i).dmPrintQuality
        else if a='scale' then result:=PrinterDeviceMode(i).dmScale
        else if a='panningwidth' then result:=PrinterDeviceMode(i).dmPanningWidth
        else if a='panningheight' then result:=PrinterDeviceMode(i).dmPanningHeight
        else if a='color' then result:=PrinterDeviceMode(i).dmColor
        else if a='duplex' then result:=PrinterDeviceMode(i).dmDuplex
        else if a='xres' then GetDeviceCaps(Printer.Handle, LOGPIXELSX)
        else if a='yres' then GetDeviceCaps(Printer.Handle, LOGPIXELSY)
        else if a='yresolution' then result:=PrinterDeviceMode(i).dmYResolution
        else if a='fields' then result:=PrinterDeviceMode(i).dmFields
        else if a='ttoption' then result:=PrinterDeviceMode(i).dmTTOption 
        else if a='collate' then result:=PrinterDeviceMode(i).dmCollate 
        else if a='displayflags' then result:=PrinterDeviceMode(i).dmDisplayFlags
        else if (a='displayfrequency') or (a='displayfreq') then result:=PrinterDeviceMode(i).dmDisplayFrequency
        else if (a='didther') or (a='dithertype') then result:=PrinterDeviceMode(i).dmDitherType
        else if (a='media') or (a='mediatype') then result:=PrinterDeviceMode(i).dmMediaType 
        else if a='papersize' then result:=PrinterDeviceMode(i).dmPaperSize
        else if (a='title') or (a='name') then result:=Printer.Title
        else result:=Printer.Printers.Count
      end else result:=Printer.Printers[i];
      Printer.PrinterIndex:=j;
    end else if a='ports' then
      if nextChar=ARRAYCHAR then begin
        readChar; a:=readExpression;
        if readChar<>']' then log_('<expected '']'''+atline);
        if VarIsNumeric(a) then result:=integer(IdPorts[VarAsType(a,varInteger)]);
      end else result:=IdPorts.Count
    else if a='languages' then
      if nextChar=ARRAYCHAR then begin
        readChar; a:=readExpression;
        if readChar<>']' then log_('<expected '']'''+atline);
        if VarIsNumeric(a) then i:=VarAsType(a,varInteger) else i:=-1;
        if nextChar=MEMBERCHAR then begin
          a:=LowerCase(readMethodName);
          if a='id' then
            if (i>=0) and (i<Languages.Count) then result:=Languages.ID[i] else result:=''
          else if a='localeid' then
            if (i>=0) and (i<Languages.Count) then result:=Languages.LocaleID[i] else result:=''
          else if a='namefromlocaleid' then
            if (i>=0) and (i<Languages.Count) then result:=Languages.NameFromLocaleID[i] else result:=''
          else if a='ext' then
            if (i>=0) and (i<Languages.Count) then result:=Languages.Ext[i] else result:=''
          else if a='index' then
            if (i>=0) and (i<Languages.Count) then result:=integer(Languages.IndexOf(i)) else result:=''
          else if (i>=0) and (i<Languages.Count) then result:=Languages.Name[i] else result:=''
        end else result:=integer(Languages.Name[i]);
      end else result:=Languages.Count
    else if a='globalatom' then begin
      readChar; result:=GlobalFindAtom(PChar(VarToStr(readExp))) 
    end else if a='atom' then begin
      readChar; result:=FindAtom(PChar(VarToStr(readExp)))
    end else if a='app_handle' then result:=Application.Handle
    else if a='app_active' then result:=integer(Application.Active)
    else if a='app_name' then result:=Application.ExeName
    else if a='app_left' then result:=Left
    else if a='app_top' then result:=Top
    else if a='app_width' then result:=Width
    else if a='app_height' then result:=Height
    else if (a='app_status') or (a='statusbar') then result:=StatusBar.Panels[2].Text
    else if a='clipboard' then begin
      if nextChar<>MEMBERCHAR then
        if Clipboard.HasFormat(CF_TEXT) then result:=Clipboard.AsText else result:=''
      else begin
        a:=readMethodName;
        if a='is_text' then result:=Clipboard.HasFormat(CF_TEXT)
        else if a='is_bitmap' then result:=Clipboard.HasFormat(CF_BITMAP)
        else if a='is_metafile' then result:=Clipboard.HasFormat(CF_METAFILEPICT)
        else if a='is_picture' then result:=Clipboard.HasFormat(CF_PICTURE)
        else if a='is_component' then result:=Clipboard.HasFormat(CF_COMPONENT)
        else if a='files' then
          if nextChar=ARRAYCHAR then begin
            readChar;
            result:=ClipboardFiles(VarAsType(readExp,varInteger));
          end else result:=ClipboardFiles(-1) 
        else if a='formats' then
          if nextChar=ARRAYCHAR then begin
            readChar; a:=VarAsType(readExp,varInteger);
            if (a<0) and (a>=Clipboard.FormatCount) then result:=-1 else result:=Clipboard.Formats[a];
          end else result:=Clipboard.FormatCount
        else result:=Clipboard.AsText;
      end;
    end else if (a='systemlocale') or (a='locale') then result:=integer(GetSystemLocale)
    else if (a='processid') or (a='currentprocessid') then result:=CurrentProcessID
    else if a='timezonebias' then result:=TimeZoneBias
    else if a='utcoffset' then result:=OffsetFromUTC
    else if a='tempfilename' then result:=MakeTempFilename
    else if (a='rebootms') or (a='ticks') or (a='tickcount') then result:=GetTickCount
    else if a='ioresult' then result:=IOResult
    else if a='getlasterror' then result:=GetLastError
    else if a='waveoutdevs' then result:=WaveOutGetNumDevs
    else if a='online' then result:=InternetGetConnectedState(nil,0)
    else if a='breakstyle' then
      if DefaultTextLineBreakStyle=tlbsLF then result:=LF else result:=CR+LF
    else if (a='arg') or (a='argument') or (a='param') or (a='parameter') then
      if not (readChar in ['(',ARRAYCHAR]) then
        result:=paramcount
      else begin
        skipWhiteSpace; a:=readExp;
        j:=VarAsType(a,varByte);
        if (j>=0) or (j<=paramcount) then result:=paramstr(j) else result:='';
      end
    else if (a='env') or (a='envvar') or (a='environment') then
      if readChar in ['(',ARRAYCHAR] then begin
        skipWhiteSpace;
        result:=GetEnvironmentVariable(VarToStr(readExp));
      end else result:=''
    else if a='mimetype' then
      if readChar in ['(',ARRAYCHAR] then begin
        skipWhiteSpace;
        result:=GetMIMETypeFromFile(VarToStr(readExp));
      end else result:='*/*'
    else if (a='src') or (a='source') or (a='script') then
      if nextChar=ARRAYCHAR then begin
        readChar; skipWhiteSpace; a:=readExp;
        if VarIsNumeric(a) then i:=integer(a) else i:=-1;
        if (i>=0) or (i<script.Count) then result:=script[i] else result:='';
      end else if readChar=MEMBERCHAR then begin
        j:=col; a:=LowerCase(readChunk);
        if a='includes' then
          if nextChar=ARRAYCHAR then begin
            readChar; a:=readExp;
            if VarIsNumeric(a) then i:=integer(a) else i:=-1;
            if (i>=0) and (i<=UBound(includes)) then
              if nextChar=MEMBERCHAR then begin
                a:=LowerCase(readMethodName);
                if a='startline' then result:=includes[i][incSTART]
                else if a='exitline' then result:=includes[i][incEXITLINE]
                else if (a='length') or (a='numlines') then result:=includes[i][incEXITLINE]-includes[i][incSTART]
                else if (a='name') or (a='filename') then result:=includes[i][incFILENAME]
                else begin
                  result:=includes[i][incEXITLINE]-includes[i][incSTART];
                  col:=j;
                end;
              end else if nextChar=ARRAYCHAR then begin
                readChar; a:=readExp;
                if varIsNumeric(a) then a:=integer(a) else a:=-1;
                if (a>=0) and (a<includes[i][incEXITLINE]-includes[i][incSTART]) then result:=script[includes[i][incSTART]+a]
                else result:='';
              end else begin
                result:=includes[i][incFILENAME];
                col:=j;
              end
          end else result:=UBound(includes)+1
        else if (a='pos') or (a='position') then result:=System.Copy(atline,2,maxint)
        else if a='name' then result:=ScriptName
        else if a='count' then result:=script.Count
        else begin
          col:=j;
          result:=UBound(includes)+1;
        end
      end else result:=script.Count
    else if a='localname' then result:=FTP.LocalName
    else if a='getvolume' then result:=GetVolume
    else if a='volume' then begin
      i:=GetVolume; j:=dword(i) shr 16; i:=word(i);
      result:=trunc((i+j)/1310.7);
    end else if a='leftvolume' then result:=word(GetVolume)
    else if a='rightvolume' then result:=GetVolume shr 16
    else if a='windowsproductkey' then result:=WindowsProductKey
    else if a='bde' then result:=integer(dbiInit(nil)=DBIERR_NONE)
    else if a='keyboard' then result:=CurrentKeyboard
    else if a='isactiveobject' then begin
      readChar; result:=isActiveObject(readExpression);
    end else if (a='regex') or (a='match') then with PerlRegEx do
      if readChar=MEMBERCHAR then begin
        a:=LowerCase(readChunk);
        if a='subject' then result:=Subject
        else if a='regex' then result:=RegEx
        else if a='replacement' then result:=Replacement
        else if a='match' then result:=integer(Match)
        else if a='matchedexpression' then result:=integer(MatchedExpression)
        else if a='offset' then result:=MatchedExpressionOffset 
        else if a='casesensitive' then result:=integer(Options*[preCaseless]=[])
        else if (a='caseless') or (a='caseinsensitive') then result:=integer(Options*[preCaseless]<>[])
        else if a='multiline' then result:=integer(Options*[preMultiline]<>[])
        else if a='singleline' then result:=integer(Options*[preSingleLine]<>[])
        else if a='extended' then result:=integer(Options*[preExtended]<>[])
        else if a='anchored' then result:=integer(Options*[preAnchored]<>[])
        else if a='dollarendonly' then result:=integer(Options*[preDollarEndOnly]<>[])
        else if a='extra' then result:=integer(Options*[preExtra]<>[])
        else if a='ungreedy' then result:=integer(Options*[preUngreedy]<>[])
        else if a='bol' then result:=integer(State*[preNotBOL]=[])
        else if a='eol' then result:=integer(State*[preNotEOL]=[])
        else if a='empty' then result:=integer(State*[preNotEmpty]=[])
        else if a='subexpressions' then result:=SubExpressionCount 
      end else begin
        Subject:=readExpression;
        readChar; RegEx:=readExp;
        result:=integer(Match);
      end
    else if a='filemapping' then begin
      a:=LowerCase(readMethodName);
      if a='msgid' then result:=FileMapping.MsgId
      else if a='msg' then result:=FileMapping.HMsg
      else if a='handle' then result:=FileMapping.HMap 
      else if a='filename' then result:=FileMapping.FileName  
      else if a='size' then result:=FileMapping.size
      else if a='sync' then result:=integer(FileMapping.sync)
      else result:=FileMapping.Buffer
    end else col:=j
  end else if a='timer' then begin
    j:=col;
    if readChar<>MEMBERCHAR then begin
      if timewatch=twMEASURE then result:=now-timestart else
      if timewatch=twLAP then result:=timestart else result:=0.0;
      exit;
    end;
    a:=LowerCase(readChunk);
    if a='now' then result:=double(now) else
    if (a='value') or (a='show') or (a='display') or (a='lap') then begin
      if timewatch=twMEASURE then result:=now-timestart else
      if timewatch=twLAP then result:=timestart else result:=0.0
    end else if a='date' then result:=trunc(double(now))
    else if a='time' then result:=frac(double(now))
    else col:=j;
  end else if a='registry' then begin
    j:=col;
    if readChar<>MEMBERCHAR then begin
      result:=IncludeTrailingBackSlash(HKEY2str(reg.RootKey))+reg.CurrentPath;
      exit;
    end;
    a:=LowerCase(readChunk);
    if (a='rootkey') or (a='root') then result:=HKEY2str(reg.RootKey)
    else if a='currentkey' then result:=reg.CurrentKey
    else if a='access' then result:=reg.Access
    else if (a='directory') or (a='dir') then result:=ExtractFileName(reg.CurrentPath)
    else if (a='lazywrite') or (a='lazy') then if reg.LazyWrite then result:=1 else result:=0
    else if (a='hassubkeys') or (a='haskeys') then result:=integer(reg.HasSubKeys)
    else if (a='currentpath') or (a='path') then result:=reg.CurrentPath
    else if (a='numkeys') or (a='keys') or (a='numsubkeys') then result:=gki(gkiKEYS)
    else if (a='numvalues') or (a='values') then result:=gki(gkiVALUES)
    else if (a='longest') or (a='maxdatasize') then result:=gki(gkiLONGEST)
    else if (a='lastwrite') or (a='lastaccess') or (a='modified') then result:=gki(gkiMODIFIED)
    else if (a='keyexist') or (a='keyexists') or (a='iskey') then begin
      readChar; a:=readExp;
      result:=integer(reg.KeyExists(VarToStr(a)));
    end else if (a='valueexist') or (a='valueexists') or (a='isvalue') then begin
      readChar; a:=readExp;
      result:=integer(reg.ValueExists(VarToStr(a)));
    end else if (a='getsize') or (a='sizeof') or (a='size') then begin
      readChar; a:=readExp;
      result:=integer(reg.GetDataSize(VarToStr(a)));
    end else col:=j;
  end else if a='files' then begin
    a:=readChar;
    if a=ARRAYCHAR then begin
      a:=readExp;
      fileshand:=fileItem(a);
      if fileshand<>nil then begin
        if readChar=MEMBERCHAR then begin
          a:=LowerCase(readChunk);
          if a='read' then begin
            a:=round(VarAsType(readExp,varDouble));
            if a>fileBUFSIZE then a:=fileBUFSIZE; result:='';
            result:=files_read(fileshand,integer(a));
          end else if (a='readline') or (a='readln') then begin
            skipWhiteSpace;
            if nextChar='(' then a:=VarToStr(readExp) else a:=#$D#$A;
            result:=files_read(fileshand,a);
          end else if (a='name') or (a='filename') then result:=fileshand^.filename
          else if a='fullname' then result:=ExpandFileName(fileshand^.filename)
          else if a='nameonly' then begin
            result:=ExtractFileName(fileshand^.filename);
            a:=lastIndexOf(ExtractFileExt(result),result);
            if a>0 then result:=copy(result,1,integer(a));
          end else if (a='ext') or (a='extension') then begin
            result:=ExtractFileExt(fileshand^.filename);
            result:=copy(result,2,length(result)-1);
          end else if a='path' then begin
            a:=ExpandFileName(fileshand^.filename);
            result:=system.copy(a,1,length(a)-length(ExtractFileName(fileshand^.filename))-1);
            if length(result)<3 then result:=result+'\';
          end else if (a='attr') or (a='attributes') then result:=fileshand^.attr
          else if (a='opened') or (a='isopen') then result:=integer(fileshand^.attr and fileOPENED<>0)
          else if (a='closed') or (a='isclosed') then result:=integer(fileshand^.attr and fileOPENED=0)
          else if (a='eof') or (a='end') then result:=integer(eof(fileshand^.f))
          else if (a='index') then begin
            j:=longint(fileshand);
            fileshand:=files;
            result:=-1; i:=0;
            while fileshand<>nil do
              if longint(fileshand)=j then begin
                result:=i;
                break;
              end else begin
                fileshand:=fileshand^.next;
                inc(i);
              end;
          end;
        end;
      end else log_('<could not find assigned file '''+a+''''+atline);
    end else if a=MEMBERCHAR then begin
      a:=LowerCase(readChunk);
      if (a='opened') or (a='numopened') then begin
        result:=0;
        fileshand:=files;
        while fileshand<>nil do begin
          if fileInUse(fileshand^.filename) then inc(result);
          fileshand:=fileshand^.next;
        end;
      end else if (a='bufsize') or (a='buffersize') then
        result:=fileBUFSIZE
      else begin {count}
        result:=0;
        fileshand:=files;
        while fileshand<>nil do begin
          fileshand:=fileshand^.next;
          inc(result);
        end
      end
    end;
  end else if a='log' then begin
    a:=readChar;
    if not(VarToStr(a)[1] in [MEMBERCHAR,ARRAYCHAR]) then begin
      if script.Count>0 then result:=script[script.Count-1];
      dec(col);
      exit;
    end;
    if a=ARRAYCHAR then begin
      a:=readExp;
      if VarIsNumeric(a) then begin
        a:=round(varAsType(a,varDouble));
        if (a>=0) and (a<script.Count) then
          result:=script[a]
        else begin
          result:='';
          log_('<log line ('''+VarToStr(a)+''') out of range'+atline);
        end;
      end;
    end else begin
      j:=col;
      a:=LowerCase(readChunk);
      if a='hscroll' then result:=integer(OutputListBox.ScrollWidth<>0)
      else if a='follow' then result:=integer(logfollow)
      else if a='line' then begin
        with OutputListbox do if Items.Count>0 then result:=Items[Items.Count-1] else result:='';
        col:=j;
      end else result:=script.Count
    end;
  end else begin
    result:=vars.Item(a);
    if not vars.Exists(a) then log_('<unknown symbol '''+a+''''+atline) else
      while nextChar=ARRAYCHAR do begin
        readChar; i:=vars.arrayIndex(VarToStr(a),readExp);
        if i<>-1 then result:=result[succ(i)] else result:='';
      end;
    if VarIsClear(result) then result:='';
  end;
end;  {.readVariable}

function  TFrmMain.arithmetic(a:variant; c:char; b:variant):variant;
begin
  case c of
  '+': result:=makeNumeric(a)+makeNumeric(b);
  '-': result:=makeNumeric(a)-makeNumeric(b);
  '*': result:=makeNumeric(a)*makeNumeric(b);
  '/': try result:=double(a)/double(b);
       except log_('<divide overflow'+atline);
       end;
  '\': try result:=trunc(double(a)/double(b));
       except log_('<integer divide overflow'+atline);
       end;
  '%': try result:=integer(a) mod integer(b);
       except log_('<integer modulo overflow'+atline);
       end;
  '|': if (VarType(a)=varString) and (VarType(b)=varString)
       then result:=''
       else result:=VarAsType(a,varInteger) or VarAsType(b,varInteger);
  '&': if (VarType(a)=varString) and (VarType(b)=varString)
       then result:=''
       else result:=VarAsType(a,varInteger) and VarAsType(b,varInteger);
  '<': if varType(a)=varString then begin
         b:=wrapped(integer(b),0,length(VarToStr(a)));
         result:=system.copy(VarToStr(a),1,integer(b));
       end else result:=integer(a) shl VarAsType(b,varInteger);
  '>': if varType(a)=varString then begin
         b:=wrapped(integer(b),0,length(VarToStr(a)));
         result:=system.copy(VarToStr(a),1,integer(b));
       end else result:=integer(a) shr VarAsType(b,varInteger);
  ')': if varType(a)=varString then begin
         b:=wrapped(integer(b),0,length(VarToStr(a)));
         result:=system.copy(VarToStr(a),1,integer(b));
       end else result:=dword(a) shr VarAsType(b,varInteger);
  '^': if (VarType(a)=varString) and (VarType(b)=varString) 
       then result:=''
       else result:=VarAsType(a,varInteger) xor VarAsType(b,varInteger);
  '{': if varType(a)=varString then begin
         b:=wrapped(integer(b),0,length(VarToStr(a)));
         result:=system.copy(VarToStr(a),integer(b)+1,maxint)+system.copy(VarToStr(a),1,integer(b));
       end else result:=ROL(integer(a),VarAsType(b,varInteger));
  '}': if varType(a)=varString then begin
         b:=wrapped(integer(b),0,length(VarToStr(a)));
         result:=system.copy(VarToStr(a),1,integer(b))+system.copy(VarToStr(a),integer(b)+1,maxint);
       end else result:=ROR(integer(a),VarAsType(b,varInteger));
  '~': if varType(a)=varString then result:=invertedCase(VarToStr(a))
       else result:=not round(a);
  '!': if varType(a)=varString then result:=''
       else if a=0 then result:=1 else result:=0;
  CONCATCHAR:
       result:=VarToStr(a)+VarToStr(b);
  else begin
      result:=Null;
      log_('<unknown operation in expression '''+c+''''+atline);
    end;
  end;
end;  {.arithmetic}

function  TFrmMain.readExpression(const level:byte=0):variant;
var
  a:variant;
  o:integer;
  c:char absolute o;
begin
  result:=null; o:=0;
  case level of
  0:begin {relation ops}
      a:=readExpression(1);
      repeat
        c:=readChar;
        if c in ['!','>','<','=','?'] then begin
          case nextChar of
          '=': case c of
               '!': o:=$0101;
               '<': o:=$0102;
               '>': o:=$0103;
               '=': ;
               else dec(col);
               end;
          '>': if c='<' then o:=$0101 else if c='=' then o:=$0105 else dec(col);
          '?': if c='?' then o:=$0104 else dec(col);
          else dec(col);
          end;
          inc(col);
        end;
        case o of
        ord('='): a:=integer(VarSameValue(a,readExpression(1)));
        ord('<'): a:=integer(VarCompare(a,readExpression(1))=vrLessThan);
        ord('>'): a:=integer(VarCompare(a,readExpression(1))=vrGreaterThan);
        $0101:    a:=integer(not VarSameValue(a,readExpression(1)));
        $0102:    a:=integer(VarCompare(a,readExpression(1)) in [vrEqual,vrLessThan]);
        $0103:    a:=integer(VarCompare(a,readExpression(1)) in [vrEqual,vrGreaterThan]);
        $0104:    a:=readTernarOperator(a);
        $0105:    begin dec(col,2); break; end;
        else      begin dec(col); break; end;
        end; o:=0;
      until nextChar in [#0,COMMACHAR];
    end;
  1:begin {add/sub/or/xor ops}
      a:=readExpression(2);
      repeat
        c:=readChar;
        case o of
        ord('|'): a:=arithmetic(a,'|',readExpression(2));
        ord('^'): a:=arithmetic(a,'^',readExpression(2));
        ord('+'): a:=arithmetic(a,'+',readExpression(2));
        ord('-'): a:=arithmetic(a,'-',readExpression(2));
        ord(CONCATCHAR): a:=VarToStr(a)+VarToStr(readExpression(2));
        else begin dec(col); break; end;
        end;
      until nextChar=#0;
    end;
  2:begin {muldivmod ops}
      a:=readExpression(3);
      repeat
        c:=readChar;
        if c in ['*','<','>','&','|','/',':'] then begin
          case nextChar of
          '<': if c='<' then o:=$0301 else dec(col);
          '>': if c='>' then o:=$0302 else if c=':' then o:=$0303 else dec(col);
          ':': if c='<' then o:=$0304 else dec(col);
          '&': if c<>'&' then dec(col);
          '|': if c<>'|' then dec(col);
          '/': if c='|' then o:=$0306 else dec(col);
          else dec(col);
          end;
          inc(col);
          if (o=$0302) and (nextChar='>') then begin
            readChar;
            o:=$0305;
          end;
        end;
        case o of
        ord('&'),ord('*'),ord('/'),ord('%'):
          a:=arithmetic(a,c,readExpression(3));
        $0301: a:=arithmetic(a,'<',readExpression(3));
        $0302: a:=arithmetic(a,'>',readExpression(3));
        $0303: a:=arithmetic(a,'}',readExpression(3));
        $0304: a:=arithmetic(a,'{',readExpression(3));
        $0305:
          begin
            a:=arithmetic(a,'>',readExpression(3));
            if VarIsNumeric(a) then a:=Abs(a);
          end;
        $0306: a:=arithmetic(a,'\',readExpression(3));
        else
          begin dec(col); break; end;
        end; o:=0;
      until nextChar=#0;
    end;
  3:begin
      skipWhiteSpace;
      case readChar of {unary ops and power}
      '~': a:=not varAsType(readExpression(4),varInteger);
      '-': a:=-readExpression(4);
      '!': begin
          a:=readExpression(4);
          if varAsType(a,varBoolean) then a:=0 else a:=1;
        end;
      else
        begin
          dec(col);
          a:=readExpression(4);
          if readChar='*' then
            if nextChar='*' then begin
              readChar;
              a:=realpower(a,readExpression(3));
            end else dec(col)
          else dec(col);
        end;
      end;
    end;
  4:begin {atomic term}
      case nextChar of
      '"': begin
          readChar;
          a:=readExpression(6);
        end;
      '''': begin
          readChar;
          a:=readExpression(8);
        end;
      '(': begin
          readChar;
          a:=readExpression;
          if readChar<>')' then log_('<expected '')'''+atline);
        end;
      '0'..'9':
        a:=readExpression(7);
      '_','A'..'Z','a'..'z':
        a:=readExpression(5);
      '{': begin
          readChar;
          a:=readExp;
          if (a<1) or (a>length(VarToStr(result))) then a:=''
          else a:=System.copy(VarToStr(result),integer(a),1);
        end;
      '\': begin
          inc(row);
          col:=1;
          a:=readExpression(4);
        end;
      '/': begin
          readChar;
          if nextChar='*' then begin
            multirem:=row;
            while row<script.Count do begin
              repeat c:=readChar
              until c in [#0,'*'];
              if c='*' then
                if readChar='/' then begin
                  multirem:=-1;
                  break;
                end else continue;
              inc(row); col:=1;
            end;
            a:=readExpression(4);
          end else begin
            dec(col); a:='';
            log_('<unexpected term'+atline);
          end;
        end;
      else begin a:=''; log_('<unexpected term'+atline); end;
      end;
      while nextChar=MEMBERCHAR do
        a:=readStructure(a)
    end;
  5:begin {identifier or function}
      a:='';
      while nextChar in CHUNKCHARS do
        a:=a+DnCase(readChar);
      if System.Pos(' '+a+' ',' files ftp local log misc registry script timer ')<>0 then
        a:=readVariable(a)
      else if a='eval' then begin
        readChar;
        a:=VarArrayCreate([0,2],varVariant);
        a[0]:=script[row];
        a[1]:=readExpression;
        a[2]:=col;
        script[row]:=a[1];
        col:=1;
        a[1]:=readExpression;
        script[row]:=a[0];
        col:=a[2]+1;
        a:=a[1];
      end else if a='array' then begin
        readChar; o:=0;
        a:=VarArrayOf(['']);
        while not (nextChar in [#0,')']) do begin
          inc(o,2);
          varArrayRedim(a,o);
          a[o]:=readExpression;
          a[o-1]:=pred(UBound(a)) div 2;
          if nextChar='=' then begin
            readChar;
            if nextChar='>' then begin
              readChar;
              a[o-1]:=a[o];
              a[o]:=readExpression;
            end else dec(col);
          end;
          if nextChar=COMMACHAR then readChar;
        end;
        readChar;
      end else if nextChar='(' then
        if isFunction(a) then a:=readFunction(a) else log_('<unrecognized function '''+a+''''+atline)
      else
        a:=readVariable(a);
    end;
  6:begin {encoded string}
      a:='';
      repeat
        if col>length(script[row]) then begin
          log_('<Unterminated string constant'+atline);
        end else c:=readChar;
        if c='\' then begin
          c:=readChar;
          case DnCase(c) of
          'a': a:=a+#7;
          't': a:=a+#9;
          'n': a:=a+#10;
          'f': a:=a+#12;
          'r': a:=a+#13;
          'e': a:=a+#27;
          'c': a:=a+chr(ord(Upcase(readChar))-64);
          'd': a:=a+chr(trunc(numberFrom(readChar+readChar+readChar,10)));
          'x': a:=a+chr(trunc(numberFrom(readChar+readChar,16)));
          '0'..'7': a:=a+chr(trunc(numberFrom(c+readChar+readChar,8)));
          else a:=a+c;
          end;
        end else
          if c='"' then break else a:=a+c;
      until false;
    end;
  7:begin {integer or rational number}
      a:='';
      repeat
        c:=readChar;
        if c in ['0'..'9'] then a:=a+c else
        if c='.' then
          if (o and $0200=0) and (nextChar in ['0'..'9']) then begin
            a:=a+sDecimal;
            o:=o or $0200;
          end else o:=o or $0100
        else if (c='e') or (c='E') then begin
          a:=a+c;
          if nextChar in ['+','-'] then a:=a+readChar;
          a:=a+'0';
          while nextChar in ['0'..'9'] do
            a:=a+readChar;
          break;
        end else o:=o or $0100;
        if o and $0100<>0 then begin
          dec(col);
          break;
        end;
      until false;
      try a:=StrToFloat(a);
      except on EConvertError do log_('<unable to convert '''+a+''' to number'+atline);
      end;
    end;
  8:begin {non-encoded string}
      a:='';
      repeat
        c:=nextChar;
        if (c='''') or (col>=length(script[row])) then o:=o or $0100
        else a:=a+readChar;
      until o and $0100<>0;
      readChar;
    end;
  9:begin {chunk}
      a:=''; skipWhiteSpace;
      while nextChar in IDENTIFIERCHAR do
        a:=a+readChar;
    end;
  end;
  result:=a;
end;  {.readExpression}

function  TFrmMain.readExp:variant;
begin
  result:=readExpression;
  readChar;
end;  {.readExp}

function  TFrmMain.readComment:boolean;
var c:char;
begin
  result:=false;
  if (row<0) or (row>=script.Count) then exit;
  skipWhitespace;
  if multirem=-1 then
    if System.Copy(script[row],col,2)='/*' then multirem:=row;
  if multirem<>-1 then
    repeat
      repeat c:=readChar; until c in [#0,'*'];
      if c='*' then
        if nextChar='/' then begin
          readChar;
          skipWhitespace;
          multirem:=-1
        end else continue;
    until true;
  if (multirem<>-1) or (nextChar='#') then exit;
  result:=true;
end;  {.readComment}

procedure TFrmMain.processRow;
begin
  col:=1;
  if not readComment then exit;
  processStatement;
end;  {.processRow}

procedure TFrmMain.processStatement;
var
  a:string;
  b:variant;
  i:integer;
  c:char absolute i;
  l:boolean absolute i;
  fileshand:PFileNode;
begin
  if nextChar in [#0,COMMENTCHAR] then exit;
  a:=LowerCase(readChunk);
  if nextChar=':' then a:=LowerCase(readMethodName);
  if a='log' then
    if nextChar=MEMBERCHAR then begin
      a:=readMethodName;
      if a='fix' then OutputListBox.Font.Name:='Lucida Console'
      else if a='vary' then OutputListBox.Font.Name:='Verdana'
      else if (a='clear') or (a='cls') or (a='clrscr') then OutputListBox.Clear
      else if a='hr' then log(rep('-',OutputListBox.Width div succ(OutputListBox.Canvas.TextWidth('-'))))
      else if a='hscroll' then with OutputListBox do begin
        if nextChar=#0 then b:=true else b:=varAsType(readExpression,VarBoolean);
        if b then ScrollWidth:=hscroll else ScrollWidth:=0;
      end else if a='follow' then begin
        if nextChar=#0 then b:=true else b:=varAsType(readExpression,VarBoolean);
        logfollow:=b;
      end else if a='save' then begin
        a:=VarToStr(readExpression);
        try OutputListBox.Items.SaveToFile(a) except log_('<output listbox was NOT saved to file "'+a+'"'+atline) end
      end else if a='load' then begin
        a:=VarToStr(readExpression);
        try OutputListBox.Items.LoadFromFile(a) except log_('<output listbox was NOT loaded from file "'+a+'"'+atline) end
      end else if (a='dontfollow') or (a='dont_follow') then logfollow:=false
      else if a='scroll' then OutputListBox.ScrollBy(0,VarAsType(readExp,varInteger));
    end else log(VarToStr(readExpression))
  else if a='const' then begin
    a:=readChunk;
    readChar;
    b:=readExp;
    if vars.Exists(a) then log_('<can not assign value to constant '''+a+''''+atline)
    else vars.Add(a,b,vtCONSTANT);
  end else if (a='let') or (a='var') then begin
    a:=readChunk; readChar;
    b:=readExp;
    if vars.Assign(a,b)<0 then log_('<can not set '''+b+''' to '''+a+''''+atline);
  end else if a='unset' then begin
    a:=readChunk;
    vars.Remove(a);
  end else if a='return' then begin
    for i:=UBound(blockstack) downto 0 do
      if blockstack[i][blSIGN]=sgnFUNC then break;
    if blockstack[i][blSIGN]=sgnFUNC then begin
      b:=readExp;
      a:=blocks[blockstack[i][blREF]][blFUNC];
      vars.Assign(a,b);
      b:=blockstack[i][blREF];
      b:=blocks[b];
      row:=b[UBound(b)];
    end else log_('<''return'' outside of function body'+atline);
  end else if (a='func') or (a='function') then begin {skip all functions' bodies}
    b:=blockAt(row);
    row:=b[UBound(b)];
  end else if (a='endif') or (a='end_if') then begin
    a:='<''endif'' without ''if''';
    if VarIsArray(blockstack) then if blockstack[UBound(blockstack)][blSIGN]=sgnIF then a:='';
    if a='' then blockPop(blockstack) else log_(a+atline);
  end else if a='else' then begin
    a:='<''else'' without ''if''';
    if VarIsArray(blockstack) then if blockstack[UBound(blockstack)][blSIGN]=sgnIF then a:='';
    if a<>'' then begin log_(a+atline); exit; end;
    if blockstack[UBound(blockstack)][blCOND]<>0 then begin
      b:=blockAt(blockstack[UBound(blockstack)][blROW]);
      row:=abs(integer(b[UBound(b)]));
      blockPop(blockstack);
    end;
  end else if (a='elseif') or (a='else_if') or (a='elseifnot') or (a='else_if_not') then begin
    i:=1;
    if VarIsArray(blockstack) then if blockstack[UBound(blockstack)][blSIGN]=sgnIF then i:=0;
    if i<>0 then begin log_('<'''+a+''' without ''if'''+atline); exit; end;
    b:=readExp;
    if varAsType(b,varBoolean) xor ((a='elseifnot') or (a='else_if_not')) then a:=#1 else a:=#0;
    b:=blockAt(blockstack[UBound(blockstack)][blROW]);
    if not VarIsArray(b) then exit else if b[blSIGN]<>sgnIF then exit;
    if blockstack[UBound(blockstack)][blCOND]=0 then begin
      if boolean(a[1]) then begin
        b:=blockstack[UBound(blockstack)];
        b[blCOND]:=b[blCOND] or 1;
        blockstack[UBound(blockstack)]:=b;
        exit;
      end else
        for i:=ifBRANCH to UBound(b)-1 do
          if abs(b[i])=row then begin
            row:=abs(integer(b[i+1]))-1;
            break;
          end;
    end else begin
      row:=abs(integer(b[UBound(b)]));
      blockPop(blockstack);
    end;
  end else if (a='if') or (a='ifnot') or (a='if_not') then begin
    if UBound(blockstack)>STACKMAX then begin
      log_('<stack overflow'+atline);
      exit;
    end;
    blockPush(blockstack,sgnIF);
    blockAppend(blockstack,-1,row);
    b:=integer(varAsType(readExp,varBoolean));
    if a<>'if' then b:=b xor 1;
    blockAppend(blockstack,-1,b);
    if b=0 then begin
      b:=blockAt(row);
      if not VarIsArray(b) then exit else if b[blSIGN]<>sgnIF then exit;
      row:=abs(integer(b[ifBRANCH]));
      {if ifBRANCH<>UBound(b) then} dec(row);
    end;
  end else if (a='resetif') or (a='reset_if') then begin
    a:='<'''+a+''' outside if..endif block';
    if VarIsArray(blockstack) then if blockstack[UBound(blockstack)][blSIGN]=sgnIF then a:='';
    if a<>'' then begin log_(a+atline); exit; end;
    skipWhitespace;
    if nextChar='(' then b:=readExp else b:=0;
    if UBound(blockstack)>b then b:=UBound(blockstack)-b else b:=0;
    i:=VarAsType(b,varInteger);
    b:=blockstack[i];
    b[blCOND]:=0;
    blockstack[i]:=b;
  end else if (a='exitif') or (a='exit_if') or (a='breakif') or (a='break_if') then begin
    a:='<'''+a+''' outside if..endif block';
    if VarIsArray(blockstack) then if blockstack[UBound(blockstack)][blSIGN]=sgnIF then a:='';
    if a<>'' then begin log_(a+atline); exit; end;
    skipWhitespace;
    if nextChar='(' then b:=readExp else b:=0;
    for i:=VarAsType(b,varInteger) downto 0 do
      if VarIsArray(blockstack) then begin
        b:=blockstack[UBound(blockstack)];
        if b[blSIGN]=sgnIF then begin
          b:=blockAt(b[blROW]);
          row:=b[UBound(b)];
          blockPop(blockstack)
        end else break;
      end;
  end else if a='break' then begin
    skipWhitespace;
    if nextChar='(' then b:=VarAsType(readExp,varInteger) else b:=0;
    i:=integer(b)+1;
    repeat
      dec(i);
      if VarIsArray(blockstack) then begin
        b:=blockstack[UBound(blockstack)];
        if b[blSIGN]=sgnIF then inc(i) else
        if b[blSIGN]=sgnFUNC then break;
        b:=blockAt(b[blROW]);
        row:=abs(integer(b[UBound(b)]));
        blockPop(blockstack);
      end else if i>=0 then begin
        row:=script.Count;
        break;
      end;
    until i<=0;
  end else if a='continue' then begin
    i:=UBound(blockstack);
    for i:=i downto 0 do
      if integer(blockstack[i][blSIGN]) in [sgnREPEAT,sgnWHILE,sgnFOR] then break
      else blockPop(blockstack);
    b:=0;
    if VarIsArray(blockstack) then b:=blockstack[i][blSIGN];
    case b of
    sgnREPEAT,sgnFOR:;
    sgnWHILE: row:=blockstack[i][blROW];
    else fatal:='<''continue'' outside ''repeat...until'', ''while...endwhile'' or ''for...endfor'''+atline;
    end;
  end else if a='while' then begin
    if UBound(blockstack)>STACKMAX then begin
      log_('<stack overflow'+atline);
      exit;
    end;
    b:=readExp;
    if not varAsType(b,varBoolean) then begin
      b:=blockAt(row);
      if not VarIsArray(b) then exit else if b[blSIGN]<>sgnWHILE then exit;
      row:=abs(integer(b[wlLOOP]));
    end else begin
      blockPush(blockstack,sgnWHILE);
      blockAppend(blockstack,-1,row);
    end;
  end else if (a='endwhile') or (a='loop') then begin
    a:='<'''+a+''' without ''while'''+atline;
    if VarIsArray(blockstack) then if blockstack[UBound(blockstack)][blSIGN]=sgnWHILE then a:='';
    if a<>'' then log_(a);
    b:=blockAt(blockstack[UBound(blockstack)][blROW]);
    if not VarIsArray(b) then exit else if b[blSIGN]<>sgnWHILE then exit;
    i:=row;
    row:=b[blROW];
    col:=b[wlCOL];
    b:=readExp;
    if not varAsType(b,varBoolean) then begin
      row:=i;
      blockPop(blockstack);
    end;
  end else if a='repeat' then begin
    if UBound(blockstack)>STACKMAX then begin
      log_('<stack overflow'+atline);
      exit;
    end;
    blockPush(blockstack,sgnREPEAT);
    blockAppend(blockstack,-1,row);
  end else if (a='until') or (a='endrepeat') then begin
    a:='<''until'' without ''repeat'''+atline;
    if VarIsArray(blockstack) then if blockstack[UBound(blockstack)][blSIGN]=sgnREPEAT then a:='';
    if a<>'' then log_(a);
    b:=readExp;
    if not varAsType(b,varBoolean) then begin
      b:=blockAt(blockstack[UBound(blockstack)][blROW]);
      if not VarIsArray(b) then exit else if b[blSIGN]<>sgnREPEAT then exit;
      row:=b[blROW];
    end else blockPop(blockstack);
  end else if a='for' then begin
    if UBound(blockstack)>STACKMAX then begin
      log_('<stack overflow'+atline);
      exit;
    end;
    blockPush(blockstack,sgnFOR);
    blockAppend(blockstack,-1,row);
    skipWhitespace; readChar;
    repeat processStatement until readChar in [#0,';'];
    if not varAsType(readExpression,varBoolean) then begin
      b:=blockAt(row);
      if not VarIsArray(b) then exit else if b[blSIGN]<>sgnFOR then exit;
      row:=b[frEND];
      blockPop(blockstack);
    end;
  end else if (a='endfor') or (a='end_for') or (a='next') then begin
    a:='<''endfor'' without ''for'''+atline;
    if VarIsArray(blockstack) then begin
      b:=blockAt(blockstack[UBound(blockstack)][blROW]);
      if b[blSIGN]=sgnFOR then a:='';
    end;
    if a<>'' then begin log_(a); exit; end;
    row:=b[blROW];
    col:=b[frSTEP];
    i:=b[frCOND];
    repeat processStatement until readChar in [#0,';'];
    col:=i;
    if not varAsType(readExpression,varBoolean) then begin
      b:=blockAt(blockstack[UBound(blockstack)][blROW]);
      row:=b[frEND];
      blockPop(blockstack);
    end;
  end else if (a='halt') or (a='stop') then begin
    if a='halt' then fatal:='<halting'+atline else fatal:='<stopping'+atline;
    log_(fatal);
    row:=script.Count
  end else if (a='goto') or (a='jmp') then begin
    b:=readExp;
    a:='<unrecognized target line for '''+a+''' statement'+atline;
    if VarIsNumeric(b) then begin
      b:=varAsType(b,varInteger);
      if (b>=0) and (b<script.Count) then a:='';
    end;
    if a='' then
      for i:=0 to UBound(blocks) do
        if (b>blocks[i][blROW]) and (b<=blocks[i][UBound(blocks[i])]) then begin
          fatal:='<fatal: target for ''goto'' must not be inside '''+tabBlock[integer(blocks[i][blSIGN])]+'''...'''+tabBlockEnd[integer(blocks[i][blSIGN])]+''''+atline;
          a:=fatal;
          break;
        end;
    if a='' then begin
      row:=b-1;
      blockstack:=null;
    end else log_(a);
  end else
  if a='ftp' then begin
    a:=LowerCase(readChunk);
    if (a='host') or (a='address') or (a='url') then begin
      readChar;
      FTP.Host:=VarToStr(readExpression);
    end else if a='sockshost' then begin
      readChar;
      FTP.SocksInfo.Host:=VarToStr(readExpression);
    end else if (a='boundip') or (a='clientip') or (a='ip') then begin
      readChar;
      FTP.BoundIP:=VarToStr(readExpression);
    end else if (a='user') or (a='username') then begin
      readChar;
      FTP.User:=VarToStr(readExpression);
    end else if (a='socksuser') or (a='socksusername') then begin
      readChar;
      FTP.SocksInfo.UserID:=VarToStr(readExpression);
    end else if (a='password') or (a='passw') or (a='pwd') then begin
      readChar;
      FTP.Password:=VarToStr(readExpression);
    end else if (a='sockspassword') or (a='sockspassw') or (a='sockspwd') then begin
      readChar;
      FTP.SocksInfo.Password:=VarToStr(readExpression);
    end else if a='port' then begin
      readChar;
      a:=readExpression;
      if not VarIsNumeric(a) then log_('<ftp.port not recognized'+atline)
      else FTP.Port:=varAsType(a,varInteger);
    end else if a='socksport' then begin
      readChar;
      a:=readExpression;
      if not VarIsNumeric(a) then log_('<ftp.port not recognized'+atline)
      else FTP.SocksInfo.Port:=varAsType(a,varInteger);
    end else if (a='recvbuffersize') or (a='recvbuffsize') then begin
      readChar;
      a:=readExpression;
      if not VarIsNumeric(a) then FTP.RecvBufferSize:=varAsType(a,varInteger);
    end else if (a='sendbuffersize') or (a='sendbuffsize') then begin
      readChar;
      a:=readExpression;
      if not VarIsNumeric(a) then FTP.SendBufferSize:=varAsType(a,varInteger);
    end else if a='bytesread' then begin
      readChar;
      ftpcfg[FTP_BYTES_READ]:=VarAsType(readExpression,varInteger);
    end else if a='byteswritten' then begin
      readChar;
      ftpcfg[FTP_BYTES_WRITTEN]:=VarAsType(readExpression,varInteger);
    end else if a='connect' then
      try
        if readChar='(' then begin
          b:=readExpression;
        end else b:=true;
        with FTP do if Connected then begin Abort; Quit; end;
        FTP.Connect(VarAsType(b,varBoolean));
      finally
      end
    else if a='openwritebuffer' then begin  
      b:=0; if readChar='(' then b:=VarAsType(readExpression,varInteger);
      if b<1 then b:=-1;
      FTP.OpenWriteBuffer(b);  
    end else if a='closewritebuffer' then FTP.CloseWriteBuffer
    else if a='cancelwritebuffer' then FTP.CancelWriteBuffer
    else if a='clearwritebuffer' then FTP.ClearWriteBuffer
    else if a='killdatachannel' then FTP.KillDataChannel
    else if a='abort' then FTP.Abort
    else if a='disconnect' then FTP.Disconnect
    else if (a='quit') or (a='bye') then FTP.Quit
    else if (a='cdup') or (a='back') or (a='up') then FTP.ChangeDirUp
    else if (a='cd') or (a='cwd') then begin
      readChar;
      FTP.ChangeDir(PChar(VarToStr(readExpression)));
    end else if (a='exe') or (a='sendcmd') or (a='cmd') or (a='command') then begin
      readChar;
      FTP.SendCmd(VarToStr(readExpression));
    end else if (a='quote') or (a='literal') or (a='site') then begin
      readChar;
      FTP.Site(PChar(VarToStr(readExpression)));
    end else if (a='ascii') or (a='text') then FTP.TransferType:=ftASCII
    else if (a='bin') or (a='binary') then FTP.TransferType:=ftBinary
    else if (a='ls') or (a='list') then begin
      if nextChar='(' then begin readChar; a:=VarToStr(readExp); end else a:='';
      getRemoteFiles(a);
    end else if (a='passive') or (a='pasv') then begin
      readChar; b:=readExpression; if VarToStr(b)='' then b:=true;
      FTP.Passive:=VarAsType(b,varBoolean);
    end else if (a='usenagle') or (a='nagle') then begin
      readChar; b:=readExpression; if VarToStr(b)='' then b:=true;
      FTP.UseNagle:=VarAsType(b,varBoolean);
    end else if (a='asciifilter') or (a='converttoascii') then begin
      readChar; b:=readExpression; if VarToStr(b)='' then b:=true;
      FTP.ASCIIFilter:=VarAsType(b,varBoolean);
    end else if (a='showpassword') or (a='showpassw') or (a='showpwd') then begin
      readChar; b:=readExpression; if VarToStr(b)='' then b:=true;
      ftpcfg[FTP_SHOW_PASSWORD]:=VarAsType(b,varBoolean);
    end else if (a='socksauth') or (a='socksauthentication') then begin
      readChar; b:=readExpression;
      FTP.SocksInfo.Authentication:=VarAsType(b,varInteger);
    end else if a='write' then begin
      readChar;
      FTP.Write(VarToStr(readExpression));
    end else if (a='writeln') or (a='writeline') then begin
      readChar;
      FTP.WriteLn(VarToStr(readExpression));
    end else if (a='get') or (a='download') then begin
      readChar; b:=VarArrayOf(['','',true]);
      b[0]:=VarToStr(readExpression); readChar;
      b[1]:=VarToStr(readExpression);
      if readChar=COMMACHAR then b[2]:=VarAsType(readExpression,varBoolean);
      if (b[0]<>'') and (b[1]<>'') then FTP.Get(b[0],b[1],b[2]);
    end else if (a='put') or (a='upload') then begin
      readChar; b:=VarArrayOf(['','',false]);
      b[0]:=VarToStr(readExpression); readChar;
      b[1]:=VarToStr(readExpression);
      if b[1]='' then b[1]:=ExtractFileName(b[0]);
      if readChar=COMMACHAR then b[2]:=VarAsType(readExpression,varBoolean);
      if (b[0]<>'') and (b[1]<>'') then FTP.Put(b[0],b[1],b[2]);
    end
  end else if a='local' then
    if nextChar=ARRAYCHAR then begin
      readChar;
      a:=VarToStr(readExp);
      b:=fileIndex(a,local);
      i:=col;
      if readChar=MEMBERCHAR then begin
        a:=LowerCase(readChunk);
        if b<>-1 then
          if a='copy' then begin
            a:=VarToStr(readExpression);
            if readChar=COMMACHAR then l:=VarAsType(readExpression,varBoolean);
            if l or not FileExists(a) then IdGlobal.CopyFileTo(local[b],VarToStr(a));
          end else if a='delete' then begin
            if readChar='(' then l:=VarAsType(readExpression,varBoolean) else l:=true;
            DeleteFile(local[b]);
          end else if a='wipe' then begin
            if readChar='(' then l:=VarAsType(readExpression,varBoolean) else l:=true;
            fileWipe(local[b],false,$FF);
            fileWipe(local[b]);
          end else if a='exe' then begin
            readChar;
            WinExec(PChar(trim(VarToStr(local[b])+' '+readExp)),SW_SHOW);
          end else if (a='setdatetime') or (a='setage') then begin
            readChar;
            FileSetDate(local[b],DateTimeToFileDate(VarAsType(readExp,varDate)));
          end else if a='setattr' then begin
            readChar;
            FileSetAttr(local[b],VarAsType(readExp,varInteger));
          end;
      end else log_('<method expected'+atline);
    end else if nextChar=MEMBERCHAR then begin
      a:=readMethodName;
      if (a='list') or (a='ls') then begin
        if nextChar='(' then begin readChar; a:=VarToStr(readExp); end else a:='';
        getLocalFiles(a);
      end else if a='cd' then begin
        readChar; a:=readExp;
        SetCurrentDirectory(PChar(a));
      end else if (a='md') or (a='mkdir') then begin
        readChar; a:=readExp;
        CreateDir(a);
      end else if a='makepath' then begin
        readChar;
        ForceDirectories(VarToStr(readExp));
      end else if a='exe' then begin
        readChar; a:=VarToStr(readExp);
        WinExec(PChar(a),SW_SHOW);
      end else if (a='exe_wait') or (a='exewait') then begin
        readChar; a:=VarToStr(readExp);
        exe_and_wait(a,SW_SHOW);
      end else if a='del' then begin
        readChar;
        DeleteFile(VarToStr(readExp));
      end else if a='wipe' then begin
        readChar; a:=VarToStr(readExp);
        fileWipe(a,false,$FF);
        fileWipe(a);
      end else if a='properties' then begin
        readChar; fileProperties(readExpression);
      end else if a='open' then begin
        readChar; ShellExecute(Handle,'open',PChar(VarToStr(readExpression)),nil,nil,SW_SHOWNORMAL)
      end; {exewait}
    end else
  else if a='timer' then begin
    a:=LowerCase(readMethodName);
    if a='reset' then
      if timewatch=twMEASURE then timestart:=now
      else timewatch:=twUNUSED
    else if (a='start') or (a='restart') then begin
      timestart:=now;
      timewatch:=twMEASURE;
    end else if (a='stop') or (a='pause') then begin
      timestart:=now-timestart;
      timewatch:=twLAP;
    end else if a='continue' then begin
      timestart:=now-timestart;
      timewatch:=twMEASURE;
    end else if a='set' then begin
      timestart:=VarAsType(readExp,varDouble);
      timewatch:=twLAP;
    end else if (a='sleep') or (a='delay') then begin
      Application.ProcessMessages;
      sleep(VarAsType(readExpression,varInteger));
    end;
  end else if a='misc' then begin
    a:=LowerCase(readMethodName);
    if (a='autoclose') or (a='autoquit') then begin
      b:=readExp;
      if VarToStr(b)='' then b:=true;
      autoclose:=VarAsType(b,varBoolean);
    end else if a='escquits' then begin
      b:=readExp;
      if VarToStr(b)='' then b:=true;
      escquits:=VarAsType(b,varBoolean);
    end else if a='follow' then begin
      b:=readExp;
      if VarToStr(b)='' then b:=true;
      logfollow:=VarAsType(b,varBoolean);
    end else if (a='ttl') or (a='scriptlife') or (a='timetolive') then begin
      b:=readExp;
      if VarToStr(b)='' then scriptEnd:=0 else scriptEnd:=now+VarAsType(b,varDouble)/86400;
    end else if a='kill' then begin
      readChar; a:=VarToStr(readExp);
      PostMessage(FindWindow(nil,PChar(a)),WM_QUIT,0,0);
    end else if a='beep' then beep
    else if a='playwav' then begin
      readChar; a:=readExpression;
      PlaySound(PChar(a),0,SND_FILENAME or SND_ASYNC);
    end else if a='soundvolume' then repeat
      readChar; i:=VarAsType(readExpression,varDouble);
      if i<0 then i:=0; if i>100 then i:=100;
      skipWhitespace;
      if readChar=COMMACHAR then begin
        b:=VarAsType(readExpression,varDouble);
        if (b>=0) and (b<=100) then begin
          setVolume(i*65535 div 100,b*65535 div 100);
          break;
        end;
      end;
      i:=i*65535 div 100;
      setVolume(i,i);
    until true
    else if a='setlocaltime' then begin
      readChar; b:=VarAsType(readExpression,varDouble);
      SetLocalTime(b);
    end else if a='app_left' then begin
      readChar; Left:=VarAsType(readExpression,varInteger);
    end else if a='app_top' then begin
      readChar; Top:=VarAsType(readExpression,varInteger);
    end else if a='app_width' then begin
      readChar; Width:=VarAsType(readExpression,varInteger);
    end else if a='app_height' then begin
      readChar; Height:=VarAsType(readExpression,varInteger);
    end else if (a='app_status') or (a='statusbar') then begin
      readChar; StatusBar.Panels[2].Text:=readExpression;
    end else if (a='app_flash') or (a='flashwindow') then begin
      readChar; FlashWindow(Application.Handle,VarAsType(readExpression,varInteger));
    end else if a='app_priority' then begin
      readChar; a:=LowerCase(VarToStr(readExpression));
      if (a='1') or (a='idle') then b:=IDLE_PRIORITY_CLASS
      else if (a='2') or (a='normal') then b:=NORMAL_PRIORITY_CLASS
      else if (a='3') or (a='high') then b:=HIGH_PRIORITY_CLASS
      else if (a='4') or (a='realtime') then b:=HIGH_PRIORITY_CLASS
      else b:=0;
      if b<>0 then SetPriorityClass(GetCurrentProcess,b);
    end else if a='app_minimize' then Application.Minimize
    else if a='app_restore' then Application.Restore
    else if a='app_bringtofront' then Application.BringToFront
    else if a='clipboard' then begin
      readChar; SetClipboard(VarToStr(readExpression));
    end else if a='screen_sleep' then SendMessage(Application.Handle,wm_SysCommand,SC_MonitorPower,0)
    else if a='screen_wake' then SendMessage(Application.Handle,wm_SysCommand,SC_MonitorPower,-1)
    else if a='screen_saver' then begin
      readChar; b:=readExpression;
      if b='' then
        if not SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,@a[1],0) then
          if boolean(a[1]) then PostMessage(GetDesktopWindow,WM_SYSCOMMAND,SC_SCREENSAVE,0) else
        else
      else SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,integer(boolean(b)),nil,0);
    end else if a='opencdrom' then mciSendString('Set cdaudio door open',nil,0,hinstance)
    else if a='closecdrom' then mciSendString('Set cdaudio door closed wait',nil,0,handle)
    else if a='netdrive_connect' then WNetConnectionDialog(handle,RESOURCETYPE_DISK)
    else if a='netdrive_disconnect' then WNetDisconnectDialog(handle,RESOURCETYPE_DISK)
    else if a='win_controlpanels' then WinExec('rundll32 shell32.dll,Control_RunDLL',SW_SHOW)
    else if a='win_screen' then WinExec('rundll32 shell32.dll,Control_RunDLL desk.cpl,,0',SW_SHOW)
    else if a='win_keyboard' then WinExec('rundll32 shell32.dll,Control_RunDLL main.cpl,,0',SW_SHOW)
    else if a='win_multimedia' then WinExec('rundll32 shell32.dll,Control_RunDLL MMSys.cpl,,0',SW_SHOW)
    else if a='win_datetime' then WinExec('rundll32 shell32.dll,Control_RunDLL TimeDate.cpl,,0',SW_SHOW)
    else if a='win_themes' then WinExec('rundll32 shell32.dll,Control_RunDLL Themes.cpl,,0',SW_SHOW)
    else if a='win_system' then WinExec('rundll32 shell32.dll,Control_RunDLL SysDm.cpl,,0',SW_SHOW)
    else if a='win_powermanagement' then WinExec('rundll32 shell32.dll,Control_RunDLL PowerCfg.cpl,,0',SW_SHOW)
    else if a='win_net' then WinExec('rundll32 shell32.dll,Control_RunDLL NETcpl.cpl,,0',SW_SHOW)
    else if a='win_local' then WinExec('rundll32 shell32.dll,Control_RunDLL Intl.cpl,,0',SW_SHOW)
    else if a='win_internet' then WinExec('rundll32 shell32.dll,Control_RunDLL InetCpl.cpl,,0',SW_SHOW)
    else if a='win_apps' then WinExec('rundll32 shell32.dll,Control_RunDLL AppWiz.cpl,,0',SW_SHOW)
    else if a='win_control_rundll' then begin
      readChar; a:=readExpression;
      if readChar=COMMACHAR then i:=VarAsType(readExpression,varInteger) else i:=0;
      WinExec(PChar('rundll32 shell32.dll,Control_RunDLL '+a+',,'+IntToStr(i)),SW_SHOW);
    end else if a='win_logoff' then begin
      b:=0;
      if nextChar='(' then begin
        readChar;
        if VarAsType(readExpression,varBoolean) then b:=EWX_FORCE;
      end;
      ExitWindowsEx(EWX_LOGOFF or b,i);
    end else if a='win_poweroff' then begin
      b:=0;
      if nextChar='(' then begin
        readChar;
        if VarAsType(readExpression,varBoolean) then b:=EWX_FORCE;
      end;
      ExitWindowsEx(EWX_POWEROFF or b,i);
    end else if a='win_reboot' then begin
      b:=0;
      if nextChar='(' then begin
        readChar;
        if VarAsType(readExpression,varBoolean) then b:=EWX_FORCE;
      end;
      ExitWindowsEx(EWX_REBOOT or b,i);
    end else if a='win_shutdown' then begin
      b:=0;
      if nextChar='(' then begin
        readChar;
        if VarAsType(readExpression,varBoolean) then b:=EWX_FORCE;
      end;
      ExitWindowsEx(EWX_SHUTDOWN or b,i);
    end else if a='win_remote_shutdown' then begin
      b:=VarArrayOf(['localhost',0,false,'This computer will be soon shut down.']);
      repeat
        if readChar='(' then b[0]:=VarAsType(readExpression,varString) else break;
        if readChar=COMMACHAR then b[1]:=VarAsType(readExpression,varInteger) else break;
        if readChar=COMMACHAR then b[2]:=VarAsType(readExpression,varBoolean) else break;
        if readChar=COMMACHAR then b[3]:=VarAsType(readExpression,varBoolean) else break;
        if readChar=COMMACHAR then b[4]:=VarAsType(readExpression,varString);
      until true;
      TimedShutDown(b[0],b[1],b[2],b[3],b[4]);
    end else if a='win_remote_shutdown_abort' then begin
      readChar;
      AbortSystemShutdown(PChar(VarToStr(readExp)));
    end else if a='mouse_x' then begin
      readChar; SetCursorPos(varAsType(readExpression,varInteger),Mouse.CursorPos.Y);
    end else if a='mouse_y' then begin
      readChar; SetCursorPos(Mouse.CursorPos.X,varAsType(readExpression,varInteger));
    end else if a='mouse_set' then begin
      readChar; b:=varAsType(readExpression,varInteger); readChar; 
      SetCursorPos(b,varAsType(readExpression,varInteger));
    end else if a='mouse_leftdown' then mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,0,0)
    else if a='mouse_leftup' then mouse_event(MOUSEEVENTF_LEFTUP,0,0,0,0)
    else if a='mouse_rightdown' then mouse_event(MOUSEEVENTF_RIGHTDOWN,0,0,0,0)
    else if a='mouse_rightup' then mouse_event(MOUSEEVENTF_RIGHTUP,0,0,0,0)
    else if a='mouse_middledown' then mouse_event(MOUSEEVENTF_MIDDLEDOWN,0,0,0,0)
    else if a='mouse_middleup' then mouse_event(MOUSEEVENTF_MIDDLEUP,0,0,0,0)
    else if a='mouse_wheelclick' then mouse_event(MOUSEEVENTF_WHEEL,0,0,120,0)
    else if a='mouse_wheel' then begin
      readChar; b:=VarAsType(readExpression,varInteger);
      mouse_event(MOUSEEVENTF_WHEEL,0,0,b,0);
    end else if a='app_hide' then ShowWindow(Application.Handle, SW_HIDE)
    else if a='app_show' then ShowWindow(Application.Handle, SW_SHOW)
    else if a='globalatom_add' then begin
      readChar; GlobalAddAtom(PChar(VarToStr(readExp)));
    end else if a='globalatom_delete' then begin
      readChar; GlobalDeleteAtom(VarAsType(readExp,varWord));
    end else if a='atom_add' then begin
      readChar; AddAtom(PChar(VarToStr(readExp)));
    end else if a='atom_delete' then begin
      readChar; DeleteAtom(VarAsType(readExp,varWord));
    end else if a='runscreensaver' then SendMessage(Handle,WM_SYSCOMMAND,SC_SCREENSAVE,0)
    else if a='activatescreensaver' then SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,1,nil,0)
    else if a='deactivatescreensaver' then SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,0,nil,0)
    else if a='presskey' then begin
      readChar; presskeys(readExpression,0);
    end else if a='releasekey' then begin
      readChar; presskeys(readExpression,KEYEVENTF_KEYUP);
    end else if a='enablebeep' then SystemParametersInfo(SPI_SETBEEP,1,NIL,SPIF_SENDWININICHANGE)
    else if a='disablebeep' then SystemParametersInfo(SPI_SETBEEP,0,NIL,SPIF_SENDWININICHANGE)
    else if a='keyboard_next' then ActivateKeyboardLayout(HKL_NEXT,0)
    else if a='keyboard_prev' then ActivateKeyboardLayout(HKL_PREV,0)
    else if a='regex' then
      if readChar<>MEMBERCHAR then else begin
        a:=LowerCase(readChunk);
        with PerlRegEx do
        if a='subject' then Subject:=VarToStr(readExpression)
        else if a='regex' then RegEx:=VarToStr(readExpression)
        else if a='replacement' then Replacement:=VarToStr(readExpression)
        else if a='casesensitive' then Options:=Options-[preCaseLess]
        else if a='caseinsensitive' then Options:=Options+[preCaseLess]
        else if a='casesensitivity' then if VarAsType(readExpression,varBoolean) then Options:=Options+[preCaseLess] else Options:=Options-[preCaseLess]
        else if a='multiline' then if VarAsType(readExpression,varBoolean) then Options:=Options-[preMultiLine] else Options:=Options+[preMultiLine]
        else if a='singleline' then if VarAsType(readExpression,varBoolean) then Options:=Options-[preSingleLine] else Options:=Options+[preSingleLine]
        else if a='extended' then if VarAsType(readExpression,varBoolean) then Options:=Options-[preExtended] else Options:=Options+[preExtended]
        else if a='anchored' then if VarAsType(readExpression,varBoolean) then Options:=Options-[preAnchored] else Options:=Options+[preAnchored]
        else if a='dollarendonly' then if VarAsType(readExpression,varBoolean) then Options:=Options-[preDollarEndOnly] else Options:=Options+[preDollarEndOnly]
        else if a='extra' then if VarAsType(readExpression,varBoolean) then Options:=Options-[preExtra] else Options:=Options+[preExtra]
        else if a='ungreedy' then Options:=Options+[preUngreedy]
        else if a='greedy' then Options:=Options-[preUngreedy]
        else if a='match' then Match
        else if a='matchagain' then MatchAgain
        else if a='replace' then Replace
        else if a='replaceall' then ReplaceAll
        else if a='bol' then if VarAsType(readExpression,varBoolean) then State:=State+[preNotBOL] else State:=State+[preNotBOL]
        else if a='eol' then if VarAsType(readExpression,varBoolean) then State:=State+[preNotEOL] else State:=State+[preNotEOL]
        else if a='empty' then if VarAsType(readExpression,varBoolean) then State:=State+[preNotEmpty] else State:=State+[preNotEmpty]
      end
    else if a='filemapping' then with FileMapping do begin
      a:=LowerCase(readMethodName);
      if a='setup' then repeat readChar;
        MsgId:=VarToStr(readExp)+#0; if MsgId='' then break;
        HMsg:=RegisterWindowMessage(addr(MsgId[1]));
        FileName:=VarToStr(readExp)+#0; if FileName='' then break;
        if readChar=',' then b:=readExp else b:=Unassigned;
        if varIsNumeric(b) then Size:=round(b) else Size:=$8000;
        if Size<1 then Size:=1; if Size>FILEMAPPING_MAX then Size:=FILEMAPPING_MAX;
        HMap:=CreateFileMapping($FFFFFFFF,nil,PAGE_READWRITE,0,Size,addr(FileName[1]));
        sync:=true; if readChar=',' then b:=readExp else b:=1;
        if VarToStr(b)<>'' then sync:=VarAsType(b,varBoolean);
      until true else if a='close' then begin
        CloseHandle(HMap); HMap:=0;
      end else if a='msgid' then begin
        MsgId:=readExpression;
        HMsg:=RegisterWindowMessage(PChar(MsgId[0]))
      end else if a='handle' then HMap:=VarAsType(readExpression,varLongWord)
      else if a='filename' then begin
        FileName:=VarToStr(readExpression);
        HMap:=CreateFileMapping($FFFFFFFF,nil,PAGE_READWRITE,0,Size,PChar(FileName));
      end else if a='size' then begin
        b:=readExpression;                    
        if VarIsNumeric(b) then if (b>=1) and (b<=FILEMAPPING_MAX) then Size:=round(b);
        if HMap<>0 then CloseHandle(HMap);
        HMap:=CreateFileMapping($FFFFFFFF,nil,PAGE_READWRITE,0,Size,PChar(FileName));
      end else if (a='buffer') or (a='flush') then begin
        if a<>'flush' then Buffer:=VarToStr(readExpression);
        if (a='flush') or sync then begin
          view:=MapViewOfFile(HMap,FILE_MAP_WRITE,0,0,succ(length(Buffer)));
          move(Buffer[1],view^,Min(length(buffer),Size)); view[StrLen(view)]:=#0; 
          UnmapViewOfFile(view);
          SendMessage(HWND_BROADCAST,HMsg,0,0);
        end;
      end else if a='fetch' then begin
        view:=MapViewOfFile(HMap,FILE_MAP_READ,0,0,size);
        Buffer:=view;
        UnmapViewOfFile(view);
      end else if a='sync' then sync:=VarAsType(readExpression,varBoolean);
    end;
  end else if a='registry' then begin
    a:=LowerCase(readMethodName);
    if (a='access') or (a='connect') then begin
      b:=readExp;
      if reg.RegistryConnect(b) then
      else log_('<fatal: could not access registry to '''+b+''''+atline);
    end else if (a='root') or (a='rootkey') then begin
      readChar;
      b:=LowerCase(VarToStr(readExpression));
      b:=StringReplace(b,'_','',[rfReplaceAll]);
      if copy(b,1,4)='hkey' then b:=copy(b,5,maxint);
      if (b='root') or (b='classes') or (b='classesroot') then b:=HKEY_CLASSES_ROOT else
      if (b='user') or (b='currentuser') then b:=HKEY_CURRENT_USER else
      if (b='machine') or (b='localmachine') then b:=HKEY_LOCAL_MACHINE else
      if (b='users') then b:=HKEY_USERS else
      if (b='config') or (b='currentconfig') then b:=HKEY_CURRENT_CONFIG else
      if (b='data') or (b='dyndata') then b:=HKEY_DYN_DATA
      else b:=HKEY_CURRENT_USER;
      reg.RootKey:=b;
    end else if (a='open') or (a='openkey') then repeat
      a:=VarToStr(readExpression);
      skipWhiteSpace; readChar; b:=false;
      if not (nextChar in [')',#0]) then b:=VarAsType(readExp,varBoolean);
      if reg.KeyExists(a) then
        if reg.OpenKey(a,b) then break;
      log_('<could not open registry key '''+a+''''+atline);
    until true
  end else if a='files' then repeat
    a:=nextChar; readChar;
    if a=ARRAYCHAR then begin
      b:=readExp;
      fileshand:=fileItem(b);
      readChar;
      if fileshand<>nil then begin
        a:=LowerCase(readChunk);
        if a='seek' then begin
          b:=VarAsType(readExp,varDouble);
          seek(fileshand^.f,round(b));
        end else if a='write' then begin
          a:=VarToStr(readExp);
          blockwrite(fileshand^.f,a[1],length(a));
        end else if a='writeln' then begin
          a:=VarToStr(readExp)+chr(13)+chr(10);
          blockwrite(fileshand^.f,a[1],length(a));
        end else if a='close' then with fileshand^ do begin
          closefile(fileshand^.f);
          attr:=attr and not fileOPENED;
        end else if a='fill' then begin  // files[i].fill(count,color)
          b:=VarArrayOf([-1,0]);
          repeat
            if readChar='(' then b[0]:=VarAsType(readExpression,varInteger) else break;
            if readChar=COMMACHAR then b[1]:=readExpression;
          until true;
          if not VarIsNumeric(b[1]) then b[1]:=integer(str2byte(b[1]));
          fileFill(fileshand^.f,b[0],b[1]);
        end else if a='discolor' then begin  // files[i].discolor(find,replace,count)
          b:=VarArrayOf([0,0,-1]);
          repeat
            if readChar='(' then b[0]:=readExpression else break;
            if readChar=COMMACHAR then b[1]:=readExpression else break;
            if readChar=COMMACHAR then b[2]:=VarAsType(readExpression,varInteger);
          until true;
          if not VarIsNumeric(b[0]) then b[0]:=integer(str2byte(b[0]));
          if not VarIsNumeric(b[1]) then b[1]:=integer(str2byte(b[1]));
          fileDiscolor(fileshand^.f,b[0],b[1],b[2]);
        end else if a='delete' then begin  // files[i].delete(count)
          b:=VarAsType(readExp,varInteger);
          fileSpaceDelete(fileshand^.f,b);
        end else if a='insert' then begin  // files[i].insert(count,color)
          b:=VarArrayOf([-1,0]);
          repeat
            if readChar='(' then b[0]:=VarAsType(readExpression,varInteger) else break;
            if readChar=COMMACHAR then b[1]:=readExpression;
          until true;
          if not VarIsNumeric(b[1]) then b[1]:=integer(str2byte(b[1]));
          fileSpaceInsert(fileshand^.f,b[0],b[1]);
        end else if a='truncate' then truncate(fileshand^.f);
      end else if LowerCase(readChunk)='open' then begin
        i:=fmOpenReadWrite;
        if readChar='(' then i:=VarAsType(readExp,varInteger);
        Files_open(b,i);
      end
    end else if a=MEMBERCHAR then begin
      a:=LowerCase(readChunk);
      if (a='closeall') or (a='close_all') then closeFiles;
    end;
  until true
  else if a='eval' then begin
    b:=readExp;
    a:=script[row];
    script[row]:=VarToStr(b);
    processRow; {dead-lock with stack overflow threat}
    script[row]:=a;
  end else if (a='endfunction') or (a='end_function') or (a='endfunc') or (a='end_func') then
  else if isFunction(a) then
    if nextChar='(' then begin
      dec(col,length(a));
      readExpression;
    end else
      readAssignment(a)
  else if vars.Exists(a) then
    readAssignment(a)
  else if a<>'' then begin
    if readChar='=' then
      if vars.Add(a,readExpression)>=0 then else log_('<error declaring variable '''+a+'''')
    else log_('<unrecognized token '''+a+''''+atline);
  end; 
end;

end.
