unit tools;

interface

uses windows,sysutils,variants,registry,clipbrd,ShellAPI,ComObj,activex,
     MMSystem,IdGlobal,ShlObj,printers,winspool;

type
  string2=string[2];
  string8=string[8];

const
  //pro trim()
  trimLEFT          =1;
  trimRIGHT         =2;
  trimBOTH          =trimLEFT or trimRIGHT;
  //pro currentUserPrivileges()
  prvlCOUNT         =0;
  prvlNAME          =1;
  prvlDISPLAYNAME   =2;
  prvlVALUE         =3;
  prvlATTRIBUTES    =4;

function  isDate(a:Variant):boolean;
function  makeNumeric(a:Variant):double;
function  str_xlat(const needle,str:string; haystack:string):string;
function  str_reverse(const str:string):string;
function  CutString(var str:variant; separator:string):string;
function  invertedCase(const s:string):string;
function  lastIndexOf(const substr,s:string):integer;
function  wrapped(n,min,max:longint):longint;
function  rep(const s:string; n:integer):string;
function  DnCase(c:char):char; assembler;
function  trim(const a:string; border:integer=trimBOTH):string;
function  HKEY2str(h:HKEY):string;
function  decodeProductKey(const HexSrc:array of Byte):string;
function  WindowsProductKey:string;
function  numberFrom(a:variant;base:byte):cardinal;
function  numberTo(a:dword;base:byte):string;
function  UBound(const v:variant):longint;
function  sDecimal:char;
function  StrToDateTimeEx(dt:string):TDateTime;
function  realpower(a,b:double):double;
function  int2chr(const v:variant; bytes:variant):variant;
function  str2byte(const s:string8):byte;
function  GetVolume:dword;
procedure SetVolume(const volLeft,volRight:word);
procedure SetClipboard(s:string);
procedure presskeys(keys:variant; release:dword);
function  GlobalMemStatus:_MEMORYSTATUS;
function  isActiveObject(const ClassName:shortstring):boolean;
procedure FileProperties(const filename:TFileName);
function  getPath(Handle:HWND; id:integer):string;
function  SystemFontSize:integer;
function  ClipboardFiles(const index:integer):variant;
function  CurrentKeyboard:string2;
function  findExe(const filename:TFileName):shortstring;
function  PrinterDeviceMode(index:integer):TDeviceMode;
function  CurrentUserPrivileges(const index,query:integer):variant;
function  TimedShutDown(const computer:string; time:word; Force,Reboot:boolean; const msg:string=''):integer;

implementation

function  isDate(a:Variant):boolean;
begin
  result:=false;
  if VarToStr(a)='' then exit;
  try
    varCast(a,a,varDate);
    result:=true;
  except
  end
end;

function  makeNumeric(a:Variant):double;
begin
  try
    result:=varAsType(a,varDouble);
  except
    result:=0;
  end;
end;

function  str_xlat(const needle,str:string; haystack:string):string;
var i,j,l:integer;
begin
  l:=length(needle); i:=length(str); if i<l then l:=i;
  for i:=1 to length(haystack) do
    for j:=1 to l do
      if haystack[i]=needle[j] then begin
        haystack[i]:=str[j];
        break;
      end;
  result:=haystack;
end;

function  str_reverse(const str:string):string;
var i:integer;
begin
  for i:=length(str) downto 1 do
    result:=result+str[i];
end;

function CutString(var str:variant; separator:string):string;
var i:integer;
begin
  i:=pos(separator,str);
  if i=0 then begin
    result:=str;
    str:='';
    exit;
  end;
  result:=copy(str,1,pred(i));
  str:=copy(str,succ(i),maxint);
end;

function  invertedCase(const s:string):string;
var i:integer;
begin
  result:=s;
  for i:=1 to length(result) do
    if result[i] in ['A'..'Z'] then result[i]:=chr(ord(result[i])+Ord('a')-Ord('A')) else
    if result[i] in ['a'..'z'] then result[i]:=chr(ord(result[i])-Ord('a')+Ord('A'));
end;

function  lastIndexOf(const substr,s:string):integer;
var i,j:integer;
begin
  result:=0;
  if (length(s)=0) or (length(substr)=0) then exit;
  for i:=length(s)-length(substr) downto 0 do
    for j:=1 to length(substr) do
      if s[i+j]<>substr[j] then break
      else if j=length(substr) then begin
        result:=i;
        exit;
      end;
end;

function  wrapped(n,min,max:longint):longint;
begin
  if min>max then begin
    result:=min;
    min:=max;
    max:=result;
  end;
  n:=(n-min) mod (max-min+1);
  if n<0 then result:=n+max+1 else result:=n+min;
end;

function rep(const s:string; n:integer):string;
begin
  result:='';
  if n<=0 then exit;
  while n>0 do begin
    if length(result)+length(s)>255 then exit;
    result:=concat(result,s);
    dec(n);
  end;
end;

function  DnCase(c:char):char; assembler;
asm
  mov  al,c
  cmp  al,'A'
  jb   @@1
  cmp  al,'Z'
  ja   @@1
  add  al,'a'-'A'
@@1:
end;

function  trim(const a:string; border:integer=trimBOTH):string;
begin
  result:=a;
  if border and trimLEFT<>0 then
    repeat
      if result='' then break else if not(result[1] in [#0,' ']) then break;
      delete(result,1,1);
    until false;
  if border and trimRIGHT<>0 then
    repeat
      if result='' then break else if not(result[length(result)] in [#0,' ']) then break;
      SetLength(result,length(result)-1);
    until false;
end;

function HKEY2str(h:HKEY):string;
begin
  case h of
  HKEY_CLASSES_ROOT:   result:='HKEY_CLASSES_ROOT';
  HKEY_LOCAL_MACHINE:  result:='HKEY_LOCAL_MACHINE';
  HKEY_USERS:          result:='HKEY_USERS';
  HKEY_CURRENT_CONFIG: result:='HKEY_CURRENT_CONFIG';
  HKEY_DYN_DATA:       result:='HKEY_DYN_DATA';
  HKEY_CURRENT_USER:   result:='HKEY_CURRENT_USER';
  else                 result:='Error: Unknown registry rootkey.';
  end;
end;

function decodeProductKey(const HexSrc:array of Byte):string;
const
  STARTOFFSET:integer=$34;
  ENDOFFSET:integer=$43;
  DIGITS:array[0..23] of char=('B','C','D','F','G','H','J','K','M','P','Q','R','T','V','W','X','Y','2','3','4','6','7','8','9');
  dLen:integer=29;
  sLen:integer=15;
var
  hexDigitalPID:array of cardinal;
  Des:array of char;
  i,n:integer;
  hn,Value:cardinal;
begin
  SetLength(HexDigitalPID,dLen);
  for i:=StartOffset to EndOffset do HexDigitalPID[i-StartOffSet]:=HexSrc[i];
  SetLength(Des,dLen+1);
  for i:=dLen-1 downto 0 do
    if succ(i) mod 6<>0 then begin
      hn:=0;
      for n:=sLen-1 downto 0 do begin
        Value:=(hn shl 8) or HexDigitalPID[n];
        HexDigitalPID[n]:=Value div 24;
        hn:=Value mod 24;
      end;
      Des[i]:=Digits[hn];
    end else Des[i]:='-';
  Des[dLen]:=Chr(0);
  for I:=0 to Length(Des) do Result:=Result+Des[I];
end;

function WindowsProductKey:string;
var
  Reg:TRegistry;
  binarySize:integer;
  HexBuf:array of byte;
begin
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKeyReadOnly('\SOFTWARE\Microsoft\Windows NT\CurrentVersion') then
      if Reg.GetDataType('DigitalProductId')=rdBinary then begin
        binarySize:=Reg.GetDataSize('DigitalProductId');
        SetLength(HexBuf,binarySize);
        if binarySize > 0 then Reg.ReadBinaryData('DigitalProductId',HexBuf[0],binarySize);
      end;
  finally
    FreeAndNil(Reg);
  end;
  Result:=DecodeProductKey(HexBuf);
end;

function  numberFrom(a:variant;base:byte):cardinal;
var i:integer;
  function  digit:byte;
  begin
    result:=ord(VarToStr(a)[i]);
    if base<=35 then begin
      if result>=ord('a') then dec(result,ord('a')-ord('A'));
      dec(result,ord('0'));
      if result>=10 then dec(result,ord('A')-ord('0')-10);
      if result>=base then result:=0;
    end;
  end;
begin
  result:=0;
  a:=VarToStr(a);
  if base<=1 then begin
    if base=1 then result:=length(a);
    exit;
  end;
  for i:=1 to length(a) do
    result:=result*base+digit;
end;

function  numberTo(a:dword;base:byte):string;
  function  digit(n:byte):char;
  begin
    if base=0 then result:='0' else
    if base<=35 then begin
      result:=chr(n+ord('0'));
      if ord(result)>ord('9') then inc(result,ord('A')-ord('0')-10);
    end else result:=chr(n);
  end;
begin
  result:='';
  if base=0 then exit; 
  repeat
    result:=digit(a mod base)+result;
    a:=(a-a mod base) div base;
  until a=0;
end;

function  UBound(const v:variant):longint;
begin
  result:=-1;
  if VarIsArray(v) then result:=VarArrayHighBound(v,1);
end;

var cachedDecimal:char;
function sDecimal:char;
var
  reg:TRegistry;
  res:string[1];
begin
  result:=cachedDecimal;
  if result in ['.',',',':',';','_'] then exit;
  try
    reg:=TRegistry.Create;
    reg.RootKey:=HKEY_CURRENT_USER;
    reg.OpenKey('\Control Panel\International',false);
    if reg.KeyExists('sDecimal') then begin
      res:=System.copy(reg.ReadString('sDecimal'),1,1);
      cachedDecimal:=res[1];
      result:=cachedDecimal;
    end else
      if reg.ReadString('Locale')='00000405'
      then result:=','
      else result:='.';
    reg.CloseKey;
    reg.Destroy;
  except
  end;
  if not(result in ['.',',',':',';','_']) then result:=',';
  cachedDecimal:=result;
end;

function StrToDateTimeEx(dt:string):TDateTime;
const SShortMonthNames:array[0..11] of string[3]=
  ('jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec');
var
  i,y,m,d:word;
  tmp:string[3];
begin
  result:=now;
  DecodeDate(result,y,m,d); m:=1; d:=1;
  tmp:=LowerCase(copy(dt,1,3));
  for i:=0 to 11 do
    if tmp=SShortMonthNames[i] then begin
      m:=i+1;
      break;
    end;
  for i:=4 to length(dt) do
    if dt[i] in ['0'..'9'] then break;
  tmp:=trim(copy(dt,i,2),trimBOTH);
  try
    d:=StrToInt(tmp);
    result:=EncodeDate(y,m,d);
    result:=result+StrToTime(copy(dt,i+length(IntToStr(d))+1,11));
  except
  end;
end;

function  realpower(a,b:double):double;
begin
  if a<=0 then result:=-1.0
  else begin
    b:=b*ln(a);
    if b<709.0 then result:=exp(b) else result:=1.7E308;
  end;
end;

function  int2chr(const v:variant; bytes:variant):variant;
var i,j:integer;
begin
  result:='';
  if not VarIsNumeric(v) then exit;
  if not VarIsNumeric(bytes) then bytes:=4;
  if bytes>8 then bytes:=8;
  for i:=bytes-1 downto 0 do begin
    j:=round(v) shr (8*i);
    if j=0 then result:=result+'\0' else result:=result+chr(j);
  end;
end;

function  str2byte(const s:string8):byte;
begin
  result:=0;
  if length(s)>0 then result:=ord(s[1]);
end;

function GetVolume:dword;
var
  hWO:HWAVEOUT;
  waveF:TWAVEFORMATEX;
begin
  result:=0;
  FillChar(waveF,SizeOf(waveF),0);
  waveOutOpen(@hWO,WAVE_MAPPER,@waveF,0,0,0);
  waveOutGetVolume(hWO,@result);
  waveOutClose(hWO);
end;

procedure SetVolume(const volLeft,volRight:word);
var
  hWO:HWAVEOUT;
  waveF:TWAVEFORMATEX;
  vol:DWORD;
begin
  fillchar(waveF,SizeOf(waveF),0);
  waveOutOpen(@hWO,WAVE_MAPPER,@waveF,0,0,0);
  vol:=volLeft+volRight shl 16;
  waveOutSetVolume(hWO,vol);
  waveOutClose(hWO);
end;

procedure SetClipboard(s:string);
var a:array[0..255] of char;
begin
  StrPCopy(a,s);
  Clipboard.SetTextBuf(a);
end;

procedure presskeys(keys:variant; release:dword);
type
  TKey2VK=record
    n:string[12];
    v:byte;
  end;
var
  k:shortstring;
  i:integer;
const
  MAXK2V=86;
  k2v:array[0..MAXK2V] of TKey2VK=(
   (n:'shift';v:VK_LSHIFT),
   (n:'lshift';v:VK_LSHIFT),
   (n:'rshift';v:VK_RSHIFT),
   (n:'ctrl';v:VK_LCONTROL),
   (n:'lctrl';v:VK_LCONTROL),
   (n:'rctrl';v:VK_RCONTROL),
   (n:'alt';v:VK_LMENU),
   (n:'lalt';v:VK_LMENU),
   (n:'ralt';v:VK_RMENU),
   (n:'win';v:VK_LWIN),
   (n:'rwin';v:VK_RWIN),
   (n:'apps';v:VK_APPS),
   (n:'bksp';v:VK_BACK),
   (n:'enter';v:VK_RETURN),
   (n:'pause';v:VK_PAUSE),
   (n:'prnscr';v:VK_SNAPSHOT),
   (n:'tab';v:VK_TAB),
   (n:'esc';v:VK_ESCAPE),
   (n:'up';v:VK_UP),
   (n:'down';v:VK_DOWN),
   (n:'right';v:VK_RIGHT),
   (n:'left';v:VK_LEFT),
   (n:'num0';v:VK_NUMPAD0),
   (n:'num1';v:VK_NUMPAD1),
   (n:'num2';v:VK_NUMPAD2),
   (n:'num3';v:VK_NUMPAD3),
   (n:'num4';v:VK_NUMPAD4),
   (n:'num5';v:VK_NUMPAD5),
   (n:'num6';v:VK_NUMPAD6),
   (n:'num7';v:VK_NUMPAD7),
   (n:'num8';v:VK_NUMPAD8),
   (n:'num9';v:VK_NUMPAD9),
   (n:'num*';v:VK_MULTIPLY),
   (n:'num/';v:VK_DIVIDE),
   (n:'num+';v:VK_ADD),
   (n:'num-';v:VK_SUBTRACT),
   (n:'num.';v:VK_SEPARATOR),
   (n:'numlock';v:VK_NUMLOCK),
   (n:'caps';v:VK_CAPITAL),
   (n:'scroll';v:VK_SCROLL),
   (n:'pgup';v:VK_PRIOR),
   (n:'pgdn';v:VK_NEXT),
   (n:'home';v:VK_HOME),
   (n:'end';v:VK_END),
   (n:'exe';v:VK_EXECUTE),
   (n:'help';v:VK_HELP),
   (n:'f1';v:VK_F1),
   (n:'f2';v:VK_F2),
   (n:'f3';v:VK_F3),
   (n:'f4';v:VK_F4),
   (n:'f5';v:VK_F5),
   (n:'f6';v:VK_F6),
   (n:'f7';v:VK_F7),
   (n:'f8';v:VK_F8),
   (n:'f9';v:VK_F9),
   (n:'f10';v:VK_F10),
   (n:'f11';v:VK_F11),
   (n:'f12';v:VK_F12),
   (n:'f13';v:VK_F13),
   (n:'f14';v:VK_F14),
   (n:'f15';v:VK_F15),
   (n:'f16';v:VK_F16),
   (n:'f17';v:VK_F17),
   (n:'f18';v:VK_F18),
   (n:'f19';v:VK_F19),
   (n:'f20';v:VK_F20),
   (n:'f21';v:VK_F21),
   (n:'f22';v:VK_F22),
   (n:'f23';v:VK_F23),
   (n:'f24';v:VK_F24),
   (n:'ins';v:VK_INSERT),
   (n:'del';v:VK_DELETE),
   (n:'attn';v:VK_ATTN),
   (n:'process';v:VK_PROCESSKEY),
   (n:'crsel';v:VK_CRSEL),
   (n:'exsel';v:VK_EXSEL),
   (n:'ereol';v:VK_EREOF),
   (n:'play';v:VK_PLAY),
   (n:'zoom';v:VK_ZOOM),
   (n:'pa1';v:VK_PA1),
   (n:'clear';v:VK_OEM_CLEAR),
   (n:'print';v:VK_PRINT),
   (n:'cancel';v:VK_CANCEL),
   (n:'select';v:VK_SELECT),
   (n:'space';v:VK_SPACE),
   (n:'lbutton';v:VK_LBUTTON),
   (n:'rbutton';v:VK_RBUTTON));
begin
  keys:=LowerCase(keys);
  repeat
    k:=CutString(keys,' ');
    if k='' then break else
    if length(k)=1 then
      keybd_event(ord(k[1]),MapVirtualKey(ord(k[1]),0),release,0)
    else
      for i:=0 to MAXK2V do with k2v[i] do
        if k=n then begin
          keybd_event(v,MapVirtualKey(v,0),release,0);
          break;
        end;
  until false;
end;

function  GlobalMemStatus:_MEMORYSTATUS;
begin
  GlobalMemoryStatus(result);
end;

function  isActiveObject(const ClassName:shortstring):boolean;
var  ClassID:TCLSID;  Unknown:IUnknown;
begin
  try
    ClassID:=ProgIDToClassID(ClassName);
    Result:=GetActiveObject(ClassID,nil,Unknown)=S_OK;
  except
    Result:=false;
  end;
end;

procedure  FileProperties(const filename:TFileName);
var sei:TShellExecuteInfo;
begin
  FillChar(sei,SizeOf(sei),0);
  sei.cbSize:=SizeOf(sei);
  sei.lpFile:=PChar(filename);
  sei.lpVerb:='properties';
  sei.fMask:=SEE_MASK_INVOKEIDLIST;
  ShellExecuteEx(@sei);
end;

function  getPath(Handle:HWND; id:integer):string;
var
  pidl:PItemIDList;
  path:array[0..MAX_PATH] of char;
begin
  SHGetSpecialFolderLocation(Handle,id,pidl);
  SHGetPathFromIDList(pidl,path);
  result:=path;
end;

function SystemFontSize:integer;
var DC:HDC;
begin
  DC:=GETDC(0);
  result:=GetDeviceCaps(DC,LOGPIXELSX);
  ReleaseDC(0,DC);
end;

function  ClipboardFiles(const index:integer):variant;
var
  h:THandle;
  buffer:array[0..MAX_PATH] of char;
  i,n:Integer;
begin
  result:='';
  if not Clipboard.HasFormat(CF_HDROP) then exit;
  Clipboard.Open;
  try
    h:=Clipboard.GetAsHandle(CF_HDROP);
    if h<>0 then repeat
      n:=DragQueryFile(h,$FFFFFFFF,nil,0);
      if (index<0) or (index>=n) then begin
        result:=n;
        break;
      end;
      for i:=0 to pred(n) do begin
        buffer[0]:=#0;
        DragQueryFile(h,i,buffer,SizeOf(buffer));
        if index=n then begin
          result:=string(buffer);
          break;
        end;
      end;
    until true;
  finally
    Clipboard.Close;
  end;
end;

function  CurrentKeyboard:string2;
var klv:array[0..2] of char;
begin
  GetLocaleInfo(LOWORD(GetKeyboardLayout(0)),LOCALE_SENGLANGUAGE,klv,2);
  result:=klv;
end;

function  findExe(const filename:TFileName):shortstring;
var p:PChar;
begin
  getMem(p,255);
  FindExecutable(PChar(filename+#0),'c:\',p);
  result:=p;
  freeMem(p,255);
end;

function  PrinterDeviceMode(index:integer):TDeviceMode;
var
  Device,Driver,Port:array[0..255] of char;
  DM_out,DM_in:PDeviceMode;
  size,origindex:Integer;
  DevMode:THandle;
begin
  fillChar(result,sizeof(result),0);
  origindex:=Printer.PrinterIndex;
  Printer.PrinterIndex:=index;
  Printer.GetPrinter(Device,Driver,Port,DevMode);
  if DevMode<>0 then begin
    DM_out:=nil; DM_in:=nil;
    size:=DocumentProperties(0,0,Device,DM_out^,DM_in^,0);
    GetMem(DM_out,size);
    DocumentProperties(0,0,Device,DM_out^,DM_in^,DM_OUT_BUFFER);
    result:=DM_out^;
    FreeMem(DM_out);
  end;
  Printer.PrinterIndex:=origindex;
end;

function  CurrentUserPrivileges(const index,query:integer):variant;
const TokenSize=800;
var
  hToken:THandle;
  pTokenInfo:PTOKENPRIVILEGES;
  ReturnLen, NameSize, DisplSize, LangId:dword;
  PrivName, DisplayName: PChar;
begin
  result:='';
  GetMem(pTokenInfo, TokenSize);
  GetMem(PrivName, 255);
  GetMem(DisplayName, 255);
  try
    if not OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then exit;
    if not GetTokenInformation(hToken, TokenPrivileges, pTokenInfo, TokenSize, ReturnLen) then exit;
    if query=0 then begin
      result:=pTokenInfo.PrivilegeCount;
      exit;
    end;
    if (index<0) or (index>=pTokenInfo.PrivilegeCount) then exit;
    DisplSize:=255; NameSize :=255;
    if not LookupPrivilegeName(nil, pTokenInfo.Privileges[index].Luid, PrivName, Namesize) then exit;
    case query of
    prvlNAME:
      result:=String(PrivName);
    prvlDISPLAYNAME:
      if LookupPrivilegeDisplayName(nil, PrivName, DisplayName, DisplSize, LangId) then
        result:=String(DisplayName);
    prvlVALUE:
      result:=pTokenInfo.Privileges[index].Luid;
    prvlATTRIBUTES:
      result:=pTokenInfo.Privileges[index].Attributes;
    end;
  finally
    FreeMem(PrivName);
    FreeMem(DisplayName);
    FreeMem(pTokenInfo);
  end;
end;

function  TimedShutDown(const computer:string; time:word; Force,Reboot:boolean; const msg:string=''):integer;
var
  rl,hToken:cardinal;
  tkp:TOKEN_PRIVILEGES;
begin
  result:=-1;
  if not OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then exit;
  if LookupPrivilegeValue(nil,'SeShutdownPrivilege', tkp.Privileges[0].Luid) then begin
    tkp.Privileges[0].Attributes:=SE_PRIVILEGE_ENABLED;
    tkp.PrivilegeCount:=1;
    AdjustTokenPrivileges(hToken,false,tkp,0,nil,rl);
    if GetLastError<>ERROR_SUCCESS then result:=-3
  end else result:=-2;
  if InitiateSystemShutdown(PChar(Computer),PChar(Msg),Time,Force,Reboot) then result:=0 else result:=-4;
end; //vraci: 0=uspech, -1=token nenalezen, -2=nemam pravo, -3=nepodarilo se docasne upravit prava pro vypnuti pocitace, -4=nepodarilo se vypnout pocitac

end.
